/*	cpizxio.c

CPI-ZD䃉Cu\z

Copyright (C) CPI Technologies, Inc.

TODO
o P̃R[fBl[^Ƀm[h`тaڑĂԂŁA
vZXw`AvZXxaꂼꐧ䂷Ƃv
܂A{ł͕̃vZXP̃R[fBl[^
ł܂B
o {ł̓R}hsXbhM܂ŒʐM|[gL
܂B
MXbhĂăt[IDɂMt[Ώۃm[h
fBXpb`ƃ~[eNXɂo̓ubNsvɂȂ邩
܂B
*/

#pragma warning( disable: 4115 4201 4214 4514 )
#include <windows.h>
#pragma warning( 1: 4115 4201 4214 )
#include <tchar.h>

#if	defined( _CONSOLE ) && defined( _DEBUG )	/*[*/
#include <stdio.h>
#endif	/*]*/

#include <assert.h>
#include <stdio.h>

#if	1200 >= _MSC_VER	/*[*/
#include "tchars.h"
#endif	/*]*/
#include "cpizxio.h"

/*//////////////////////////////////////////////////////////////////////
*/

#define	EOS			'\0'	/* end of string. */
#define	LF			'\n'	/* line feed. */
#define	CR			'\r'	/* carriage return. */

#define	I_MIN_COMM		1	/* communication port #. */
#define	I_MAX_COMM		256

#define	CMS_TMO_ND		4800	/* ATND timeout. */

#define	LENGTH_OF( ar )		( sizeof ( ar ) / sizeof ( *ar ) )
#define	OFFSET_OF( tp, mb )	( ( size_t )&( ( tp* )0 )->mb )

#define	DSCA( id, st )		static char const id[] = st

/*//////////////////////////////////////////////////////////////////////
*/

static	_inline WORD PEEK_W( LPCVOID pB )
{
	return ( WORD )(
			( ( ( LPBYTE )pB )[ 0 ] << 010 )
			| ( ( LPBYTE )pB )[ 1 ]
			);
}

/*//////////////////////////////////////////////////////////////////////
*/

static	_inline DWORD PEEK_D( LPCVOID pB )
{
	return ( ( DWORD )( ( LPBYTE )pB )[ 0 ] << 030 )
			| ( ( DWORD )( ( LPBYTE )pB )[ 1 ] << 020 )
			| ( ( ( LPBYTE )pB )[ 2 ] << 010 )
			| ( ( LPBYTE )pB )[ 3 ]
			;
}

/*//////////////////////////////////////////////////////////////////////
*/

static	_inline void POKE_W( LPVOID pB, WORD vP )
{
	( ( LPBYTE )pB )[ 0 ] = ( BYTE )( vP >> 010 );
	( ( LPBYTE )pB )[ 1 ] = ( BYTE )vP;
}

/*//////////////////////////////////////////////////////////////////////
*/

static	_inline WORD SWAP_W( WORD wV )
{
	return ( WORD )( ( wV >> 010 ) | ( wV << 010 ) );
}

/*//////////////////////////////////////////////////////////////////////
*/

static	_inline DWORD SWAP_D( DWORD dV )
{
	return ( dV >> 030 )
			| ( 0x0000ff00 & ( dV >> 010 ) )
			| ( 0x00ff0000 & ( dV << 010 ) )
			| ( dV << 030 )
			;
}

/*//////////////////////////////////////////////////////////////////////
*/

static	int zx_at( HZXC hz, LPCSTR pszC, DWORD cchC, LPBYTE pb, DWORD cb, LPDWORD pcb );
static	int zx_at_rs( HZXC hz, LPCSTR pszC, DWORD cchC, LPSTR pszR, DWORD cchR, LPDWORD pcchR );

#ifdef	BF_CAPT_FRAME	/*[*/

/*//////////////////////////////////////////////////////////////////////
*/

#define	CAPT_MAX_TX	2048
#define	CAPT_MAX_RX	( 2 * CAPT_MAX_TX )

#define	DSCT( id, st )	static TCHAR const id[] = _T( st )

/*//////////////////////////////////////////////////////////////////////
*/

typedef	struct
{
	DWORD	tC;	/* current tick count. */
	TXBAF	fr[ 1 ];	/* api frame. */
}	T1CAP;

typedef	T1CAP FAR*	LP1CAP;

typedef	struct
{
	DWORD	t0;	/* 1st tick count. */
	DWORD	cTx;	/* count. */
	DWORD	cRx;	/* count. */
	T1CAP	aTx[ CAPT_MAX_TX ];
	T1CAP	aRx[ CAPT_MAX_RX ];
}	TCAP;

/*//////////////////////////////////////////////////////////////////////
*/

static	TCAP g_cap;

/*//////////////////////////////////////////////////////////////////////
*/

void zx_capt_beg( void )
{
	g_cap.cTx = 0;
	g_cap.cRx = 0;
	g_cap.t0 = GetTickCount();
}

/*//////////////////////////////////////////////////////////////////////
*/

void zx_capt_end( void )
{
DSCT( s_szFile,		"cap.log" );
DSCT( s_szOMWT,		"wt" );
DSCT( s_szFHead,	"%4s %8s %2s %2s\n" );
DSCT( s_szF,		"%4u %8lu %02X %02X" );
DSCT( s_szLn,		"\n" );
DSCT( s_szNum,		"#" );
DSCT( s_szTick,		"Tick" );
DSCT( s_szFT,		"FT" );
DSCT( s_szFID,		"ID" );
	FILE FAR*	pfLog;	/* log. */
	LP1CAP	pp;	/* iterator. */
	DWORD	ii;	/* iterator. */

	if ( _tfopen_s( &pfLog, s_szFile, s_szOMWT ) )
	{
		return;
	}

	( void )_ftprintf( pfLog, _T( "TX %lu frames.\n" ), g_cap.cTx );
	if ( g_cap.cTx )
	{
		( void )_ftprintf(
				pfLog,
				s_szFHead,
				s_szNum,
				s_szTick,
				s_szFT,
				s_szFID
				);
	}
	for ( pp = g_cap.aTx, ii = 0; ii < g_cap.cTx; pp++, ii++ )
	{
		( void )_ftprintf(
				pfLog,
				s_szF,
				ii,
				pp->tC - g_cap.t0,
				pp->fr->hd.ft,
				pp->fr->hd.fid
				);
		switch ( pp->fr->hd.ft )
		{
		default:
			( void )_ftprintf( pfLog, s_szLn );
			break;
		case XB_FT_TX_AT:
			( void )_ftprintf(
					pfLog,
					_T( " %c%c\n" ),
					pp->fr->txat.cm[ 0 ],
					pp->fr->txat.cm[ 1 ]
					);
			break;
		case XB_FT_TX_ZB:
{
DSCT( s_szF,	" %08lX-%08lX %04X bcr:%02X opt:%02X tx:" );

			( void )_ftprintf(
					pfLog,
					s_szF,
					SWAP_D( pp->fr->txzb.DH ),
					SWAP_D( pp->fr->txzb.DL ),
					SWAP_W( pp->fr->txzb.D16 ),
					pp->fr->txzb.bcr,
					pp->fr->txzb.opt
					);
}
{
			LPCSTR	ps;	/* transmit data. */

			for ( ps = pp->fr->txzb.ds; CR != *ps; ps++ )
			{
				( void )fputc( *ps, pfLog );
			}
			( void )fputc( LF, pfLog );
}
			break;
		case XB_FT_TX_RAT:
{
DSCT( s_szF,	" %08lX-%08lX %04X opt:%02X %c%c\n" );

			( void )_ftprintf(
					pfLog,
					s_szF,
					SWAP_D( pp->fr->txrat.DH ),
					SWAP_D( pp->fr->txrat.DL ),
					SWAP_W( pp->fr->txrat.D16 ),
					pp->fr->txrat.opt,
					pp->fr->txrat.cm[ 0 ],
					pp->fr->txrat.cm[ 1 ]
					);
}
			break;
		}
	}

	( void )_ftprintf( pfLog, _T( "RX %lu frames.\n" ), g_cap.cRx );
	if ( g_cap.cRx )
	{
		( void )_ftprintf(
				pfLog,
				s_szFHead,
				s_szNum,
				s_szTick,
				s_szFT,
				s_szFID
				);
	}
	for ( pp = g_cap.aRx, ii = 0; ii < g_cap.cRx; pp++, ii++ )
	{
		( void )_ftprintf(
				pfLog,
				s_szF,
				ii,
				pp->tC - g_cap.t0,
				pp->fr->hd.ft,
				pp->fr->hd.fid
				);
		switch ( pp->fr->hd.ft )
		{
		default:
			( void )_ftprintf( pfLog, s_szLn );
			break;
		case XB_FT_RX_AT:
			( void )_ftprintf(
					pfLog,
					_T( " %c%c st:%02X\n" ),
					pp->fr->rxat.cm[ 0 ],
					pp->fr->rxat.cm[ 1 ],
					pp->fr->rxat.st
					);
			break;
		case XB_FT_RX_MST:
			( void )_ftprintf(
					pfLog,
					_T( " stModem:%02X\n" ),
					pp->fr->rxmst.st
					);
			break;
		case XB_FT_RX_ZB_ST:
{
DSCT( s_szF,	" %04X nRetry:%d stDelivery:%02X stDiscovery:%02X\n" );

			( void )_ftprintf(
					pfLog,
					s_szF,
					SWAP_W( pp->fr->rxzbst.S16 ),
					pp->fr->rxzbst.nRetry,
					pp->fr->rxzbst.stDelivery,
					pp->fr->rxzbst.stDiscovery
					);
}
			break;
		case XB_FT_RX_ZB:
{
DSCT( s_szF,	" %08lX-%08lX %04X opt:%02X rx:" );

			( void )_ftprintf(
					pfLog,
					s_szF,
					SWAP_D( pp->fr->rxzb.SH ),
					SWAP_D( pp->fr->rxzb.SL ),
					SWAP_W( pp->fr->rxzb.S16 ),
					pp->fr->rxzb.opt
					);
}
{
			LPCSTR	ps;	/* received data. */

			for ( ps = pp->fr->rxzb.ds; CR != *ps; ps++ )
			{
				( void )fputc( *ps, pfLog );
			}
			( void )fputc( LF, pfLog );
}
			break;
		case XB_FT_RX_RAT:
{
DSCT( s_szF,	" %08lX-%08lX %04X %c%c st:%02X\n" );

			( void )_ftprintf(
					pfLog,
					s_szF,
					SWAP_D( pp->fr->rxrat.SH ),
					SWAP_D( pp->fr->rxrat.SL ),
					SWAP_W( pp->fr->rxrat.S16 ),
					pp->fr->rxrat.cm[ 0 ],
					pp->fr->rxrat.cm[ 1 ],
					pp->fr->rxrat.st
					);
}
			break;
		}
	}

	( void )fclose( pfLog );
}

#endif	/*]*/

/*//////////////////////////////////////////////////////////////////////
*/

DSCA( s_szZc001,	"CPI-ZC001" );
DSCA( s_szZd132,	"CPI-ZD132" );
DSCA( s_szZd232,	"CPI-ZD232" );
DSCA( s_szZd332,	"CPI-ZD332" );

/*//////////////////////////////////////////////////////////////////////
*/

#ifdef	_DEBUG	/*[*/

typedef	struct	/* error counter. */
{
	/* t[Mɂ */
	DWORD	cWriteFile;	/* WriteFiles */
				/* GetOverlappedResults */
	DWORD	cWGetOverlappedResult;
	DWORD	cWriteFileCb;	/* WriteFileoCgُ */

	/* f~^уoCgMɂ */
	DWORD	c0ReadFile;	/* ReadFiles */
				/* GetOverlappedResults */
	DWORD	c0GetOverlappedResult;
	DWORD	cHeadCb;	/* oCgs */
	DWORD	cDelimiter;	/* f~^ُ */

	/* {́{checksumMɂ */
	DWORD	c1ReadFile;	/* ReadFiles */
				/* GetOverlappedResults */
	DWORD	c1GetOverlappedResult;
	DWORD	cBodyCb;	/* oCgs */
	DWORD	cChecksum;	/* checksumُ */

	/* Mt[ */
	DWORD	cUnexpected;	/* zO */
	DWORD	cModemStatus;	/* fXe[^X */

	/* ̃t[҂Mɂ */
	DWORD	cFType;		/* zÕt[^Cv */
	DWORD	cFId;		/* zÕt[ID */

	/* ZigBeeMXe[^X܂ */
	/* ZigBeeMpPbgt[҂Mɂ */
	DWORD	cZbFType;	/* zÕt[^Cv */
	DWORD	cZbFId;		/* zÕt[ID */
	DWORD	cZbAddr;	/* zȎMAhX */

	/* ZigBeeMXe[^Xt[ɂ */
	DWORD	cZbSt;		/* foXe[^Xُ */

	/* ZigBeeMpPbgt[҂Mɂ */
	DWORD	cZbPkFType;	/* zÕt[^Cv */
	DWORD	cZbPkAddr;	/* zȎMAhX */

	/* ̑ */
				/* ZigBeeMXe[^X */
	DWORD	cReversed;	/* ZigBeeMpPbgt[M */

	/* ԂATR}ht[ɂ */
	DWORD	cAtRSCb;	/* oCgs */

	/* WrbglԂuATR}ht[ɂ */
	DWORD	cRatRBCb;	/* oCgs */

	/* ԂȂZDR}hsɂ */
	DWORD	cZbRNCb;	/* oCgُ */

	/* WrbglԂZDR}hsɂ */
	DWORD	cZbRBCb;	/* oCgs */

	/* ԂZDR}hsɂ */
	DWORD	cZbRSCb;	/* oCgs */

	/* TSR}hsɂ */
	DWORD	cZdTSCb;	/* oCgs */
}	TERRC;

#endif	/*]*/

static	struct	/* coordinator control structures. */
{
				/* all ports. */
	TZXC	azc[ 1 + I_MAX_COMM ];
#ifdef	_DEBUG	/*[*/
	TERRC	ce;		/* error counter. */
#endif	/*]*/
	BYTE	fid;
}	s_v;

/*//////////////////////////////////////////////////////////////////////
nh̑ÓmF܂B
in	hz	nhB
ret	0	Ół͂܂B
	else	ÓłB
*/

static	_inline BOOL hz_valid( HZXC hz )
{
	if ( NULL == hz
			|| hz <= s_v.azc
			|| LENGTH_OF( s_v.azc ) + s_v.azc <= hz
			)
	{
		return FALSE;
	}

	return TRUE;
}

/*//////////////////////////////////////////////////////////////////////
nhђʐM|[gfoCXnh̑ÓmF܂B
in	hz	nhB
ret	0	Ół͂܂B
	else	ÓłB
*/

static	_inline BOOL h_valid( HZXC hz )
{
	if ( NULL == hz
			|| hz <= s_v.azc
			|| LENGTH_OF( s_v.azc ) + s_v.azc <= hz
			)
	{
		return FALSE;
	}

	return NULL != hz->hComm;
}

/*//////////////////////////////////////////////////////////////////////
m[hnh̑ÓmF܂B
in	hz	nhB
ret	0	Ół͂܂B
	else	ÓłB
*/

static	_inline BOOL hn_valid( HZXN hn )
{
	if ( NULL == hn
			|| NULL == hn->hc
			|| hn->hc <= s_v.azc
			|| LENGTH_OF( s_v.azc ) + s_v.azc <= hn->hc
			|| hn->hc->nN <= hn->ix
			)
	{
		return FALSE;
	}

	return NULL != hn->hc->hComm;
}

/*//////////////////////////////////////////////////////////////////////
nh܂B
in	hz	nhB
ret	G[R[hB
*/

static	_inline int zx_close( HZXC hz )
{
	assert( hz_valid( hz ) );

	/*
	// enter i/o blocking.
	*/

	( void )WaitForSingleObject( hz->hxComm, INFINITE );

	/*
	// close objects.
	*/

	if ( NULL != hz->hComm )
	{
		( void )CloseHandle( hz->hComm );
		hz->hComm = NULL;
	}

	if ( NULL != hz->oComm.hEvent )
	{
		( void )CloseHandle( hz->oComm.hEvent );
		hz->oComm.hEvent = NULL;
	}

	/*
	// leave i/o blocking.
	*/

	( void )ReleaseMutex( hz->hxComm );

	if ( NULL != hz->hxComm )
	{
		( void )CloseHandle( hz->hxComm );
		hz->hxComm = NULL;
	}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
ʐM|[gfoCXJ܂B
in	psz	ʐM|[gfoCX̃V{bNNB
ret	ʐM|[gfoCX̃nhԂ܂B
	NULL	sB
*/

static	_inline HANDLE dev_open( LPCTSTR psz )
{
	HANDLE	hComm;	/* communication port. */

	assert( NULL != psz );

	hComm = CreateFile(
			psz,
			GENERIC_READ | GENERIC_WRITE,
			0,
			NULL,
			OPEN_EXISTING,
			0,
			NULL
			);
	if ( INVALID_HANDLE_VALUE == hComm )
	{
		return NULL;
	}

	return hComm;
}

/*//////////////////////////////////////////////////////////////////////
^CAEgݒ肵܂B
in	hz	nhB
	cmsTmo	^CAEg [mS]B
ret	0	sB
	else	B
*/

static	_inline BOOL tmo_set( HZXC hz, DWORD cmsTmo )
{
	assert( NULL != hz );
	assert( NULL != hz->hComm );

	hz->tmo.ReadTotalTimeoutConstant = cmsTmo;

	return SetCommTimeouts( hz->hComm, &hz->tmo );
}

/*//////////////////////////////////////////////////////////////////////
ʐMp[^ݒ肵܂B
in	hz	nhB
ret	0	sB
	else	B
*/

#define	RC_BAUD_1ST	CBR_9600
#define	RC_BAUD		CBR_115200
#define	RC_BITS		8
#define	RC_STOP		ONESTOPBIT
#define	RC_PARITY	NOPARITY

static	_inline BOOL par_set( HZXC hz, DWORD baud )
{
	assert( h_valid( hz ) );

{
	DCB	dcb[ 1 ];	/* DCB. */

	dcb->DCBlength = sizeof ( dcb );
	if ( ! GetCommState( hz->hComm, dcb ) )
	{
		return FALSE;
	}

	dcb->BaudRate		= baud;
	dcb->ByteSize		= RC_BITS;
	dcb->StopBits		= RC_STOP;
	dcb->Parity		= RC_PARITY;
	dcb->fDsrSensitivity	= TRUE;
	dcb->fRtsControl	= RTS_CONTROL_ENABLE;

	if ( ! SetCommState( hz->hComm, dcb ) )
	{
		return FALSE;
	}
}

{
	if ( ! GetCommTimeouts( hz->hComm, &hz->tmo ) )
	{
		return FALSE;
	}

	hz->tmo.ReadIntervalTimeout = 120;
	hz->tmo.ReadTotalTimeoutMultiplier = 120;

	return tmo_set( hz, hz->cmsTmo );
}
}

/*//////////////////////////////////////////////////////////////////////
G[NA܂B
*/

static	_inline void err_clr( HZXC hz )
{
	assert( h_valid( hz ) );

	hz->fError = FALSE;

	( void )PurgeComm(
			hz->hComm,
			PURGE_TXABORT
					 | PURGE_RXABORT
					 | PURGE_TXCLEAR
					 | PURGE_RXCLEAR
			);

{
	DWORD	bm;	/* error bitmap. */
	COMSTAT	cst;	/* communication port status. */

	( void )ClearCommError( hz->hComm, &bm, &cst );
}
}

/*//////////////////////////////////////////////////////////////////////
nh܂B
in	hz	nhB
ret	G[R[hB
*/

int ZxClose( HZXC hz )
{
	if ( ! hz_valid( hz ) )
	{
		return ZXE_HANDLE;
	}

	return zx_close( hz );
}

/*//////////////////////////////////////////////////////////////////////
ATR}hvt[̈ꕔ쐬܂B
in	hz	nhB
out	*hz->txat
		ATR}hvt[̈ꕔB
*/

static	_inline void zx_txat_bld( HZXC hz )
{
	assert( hz_valid( hz ) );

	hz->txat.txat.chD = XB_CH_DELIM;
	hz->txat.txat.ft = XB_FT_TX_AT;
}

/*//////////////////////////////////////////////////////////////////////
XBeeJ܂B
in	iComm	ʐM|[gԍB
	cmsTmo	ʐM^CAEg [mS]B
ret	nhB
	NULL	sB
*/

HZXC ZxOpen( UINT iComm, DWORD cmsTmo )
{
	HZXC	hz;	/* control handle. */

	if ( iComm < I_MIN_COMM || I_MAX_COMM < iComm )
	{
		SetLastError( ERROR_INVALID_PARAMETER );

		return NULL;
	}

	/*
	//
	*/

	hz = iComm + s_v.azc;
	hz->cmsTmo = cmsTmo;
	hz->iComm = iComm;
	hz->fError = FALSE;
	hz->nN = 0;

	/*
	// ATR}hvt[̈ꕔ쐬
	*/

	zx_txat_bld( hz );

	/*
	// create i/o blocking mutex.
	*/

	if ( NULL == hz->hxComm )
	{
		hz->hxComm = CreateMutex( NULL, FALSE, NULL );
		if ( NULL == hz->hxComm )
		{
			return NULL;
		}
	}

	/*
	//
	*/

	if ( NULL != hz->hComm )
	{
		/*
		// already opened.
		*/

		assert( NULL != hz->oComm.hEvent );
		SetLastError( ERROR_ACCESS_DENIED );

		return NULL;
	}

	/*
	// overlapped event.
	*/

	hz->oComm.hEvent = CreateEvent( NULL, TRUE, FALSE, NULL );
	if ( NULL == hz->oComm.hEvent )
	{
		return FALSE;
	}

	for ( ; ; )			/* [vł͂܂B */
	{
				/* symbolic link. */
		TCHAR	sz[ 16 ];

		/*
		// build symbolic link.
		*/

		( void )_stprintf_s(
				sz,
				LENGTH_OF( sz ),
				_T( "\\\\.\\COM%u" ),
				iComm
				);

		/*
		// enter i/o blocking.
		*/

		( void )WaitForSingleObject( hz->hxComm, INFINITE );

		/*
		// open communication port.
		*/

		hz->hComm = dev_open( sz );
		if ( NULL == hz->hComm )
		{
			break;
		}

#ifdef	_DEBUG	/*[*/

		/*
		// reset error counter.
		*/

		( void )memset( &s_v.ce, 0, sizeof ( s_v.ce ) );

#endif	/*]*/

		/*
		// set communication parameters.
		*/

		if ( ! par_set( hz, RC_BAUD_1ST ) )
		{
			break;
		}

		err_clr( hz );

{
		DWORD	cchR;	/* # of received characters. */
		int	ri;	/* result. */

		/*
		// enter api mode.
		*/

		ri = zx_at( hz, "AP\x01", 3, NULL, 0, NULL );
		if ( ZXR_OK != ri )
		{
			break;
		}

		/*
		// obtain network id.
		*/

		ri = zx_at_rs(
				hz,
				"NI",
				2,
				hz->ni,
				sizeof ( hz->ni ),
				&cchR
				);
		if ( ZXR_OK != ri )
		{
			break;
		}
}

		/*
		// leave i/o blocking.
		*/

		( void )ReleaseMutex( hz->hxComm );

		return hz;
	}

	/*
	// error.
	*/

	/*
	// leave i/o blocking.
	*/

	( void )ReleaseMutex( hz->hxComm );

	/*
	// forgive.
	*/

	( void )zx_close( hz );

	return NULL;
}

/*//////////////////////////////////////////////////////////////////////
ʐM|[gɃANZX\ǂ𒲂ׂ܂B
in	hz	nhB
ret	0	ANZXł܂B
	else	ANZXł܂B
*/

BOOL ZxReady( HZXC hz )
{
	if ( ! h_valid( hz ) )
	{
		return FALSE;
	}

{
	DWORD	bm;

	return GetCommMask( hz->hComm, &bm );
}
}

/*//////////////////////////////////////////////////////////////////////
ʐM|[gւ̃ANZXđXbh̃ANZX܂B
in	hz	nhB
ret	G[R[hB
*/

int ZxUnlock( HZXC hz )
{
	if ( ! hz_valid( hz ) )
	{
		return ZXE_HANDLE;
	}

	assert( NULL != hz->hxComm );

	if ( ! ReleaseMutex( hz->hxComm ) )
	{
		return ZXE_SYS;
	}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
ʐM|[gւ̃ANZX擾đXbh̃ANZX֎~܂B
in	hz	nhB
	cmsTmo	^CAEgB
ret	G[R[hB
*/

int ZxLock( HZXC hz, DWORD cmsTmo )
{
	if ( ! hz_valid( hz ) )
	{
		return ZXE_HANDLE;
	}

	assert( NULL != hz->hxComm );

	if ( WAIT_OBJECT_0 != WaitForSingleObject(
			hz->hxComm,
			cmsTmo
			) )
	{
		return ZXE_LOCK;
	}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
ATR}hs܂B
in	hz	nhB
	pszC	R}h̃AhXB
	cchC	R}hB
	pb	ATR}h̃R}hf[^󂯎obt@̃AhXB
	cb	i[\ȃoCgB
	pcb	i[oCg󂯎obt@̃AhXB
out	*pcb	i[oCgB
ret	G[R[hB
*/

int ZxAt( HZXC hz, LPCSTR pszC, DWORD cchC, LPVOID pb, DWORD cb, LPDWORD pcb )
{
	if ( ! hz_valid( hz ) )
	{
		return ZXE_HANDLE;
	}

	if ( NULL == pszC || 2 > cchC )
	{
		return ZXE_ARG;
	}

	return zx_at( hz, pszC, cchC, pb, cb, pcb );
}

/*//////////////////////////////////////////////////////////////////////
t[ID
*/

static	_inline BYTE FID_INC( void )
{
	s_v.fid++;
	if ( 0 == s_v.fid || 0xff == s_v.fid )
	{
		s_v.fid = 1;
	}

	return s_v.fid;
}

/*//////////////////////////////////////////////////////////////////////
t[ID
*/

static	_inline BYTE FID_CUR( void )
{
	return s_v.fid;
}

/*//////////////////////////////////////////////////////////////////////
Pt[M܂B
in	hz	nhB
	ptx	t[̃AhXB
	cb	PoCgڂƂQoCgڂɐݒ肳oCgB
ret	G[R[hB
TODO
SRI[o[bvĂ܂B
*/

static	int fr_tx( HZXC hz, LPXBAF ptx, DWORD cb )
{
	assert( h_valid( hz ) );
	assert( NULL != ptx );
	assert( cb );
	assert( XB_CB_MAX_FRAME - sizeof ( TXBAFH0 ) >= cb );

	/*
	//
	*/

	if ( hz->fError )
	{
		err_clr( hz );
	}

	/*
	// setup.
	*/

	assert( XB_CH_DELIM == ptx->hd.chD );
	POKE_W( &ptx->hd.CB, ( WORD )cb );

	ptx->hd.fid = FID_INC();

{
	LPBYTE	pbS;	/* checksum. */
	LPBYTE	pb;	/* iterator. */

	/*
	// checksum.
	*/

	pb = &ptx->hd.ft;
	pbS = cb + pb;
	*pbS = ( BYTE )-1;
	while ( pb < pbS )
	{
		*pbS = ( BYTE )( *pbS - *pb++ );
	}
}

{
	DWORD	cbX;	/* xfered bytes. */

	/*
	// transmit.
	*/

	cb += 1 + 2 + 1;		/* delim., bytes, checksum. */

#ifdef	BF_CAPT_FRAME	/*[*/
	if ( CAPT_MAX_RX > g_cap.cTx )
	{
		g_cap.aTx[ g_cap.cTx ].tC = GetTickCount();
		( void )memcpy( g_cap.aTx[ g_cap.cTx ].fr, ptx, cb );
		g_cap.cTx++;
	}
#endif	/*]*/

	( void )ResetEvent( hz->oComm.hEvent );

	if ( ! WriteFile( hz->hComm, ptx, cb, &cbX, &hz->oComm ) )
	{
		if ( ERROR_IO_PENDING != GetLastError() )
		{
#ifdef	_DEBUG	/*[*/
			s_v.ce.cWriteFile++;
#endif	/*]*/

			return ZXE_TX;
		}
	}

	if ( ! GetOverlappedResult(
			hz->hComm,
			&hz->oComm,
			&cbX,
			TRUE
			) )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.cWGetOverlappedResult++;
#endif	/*]*/

		return ZXE_SYS;
	}

	if ( cbX != cb )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.cWriteFileCb++;
#endif	/*]*/

		return ZXE_TX;
	}
}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
0x08
ATR}h𑗐M܂B
in	hz	nhB
	ps	R}h̃AhXB
	cch	R}hB
ret	G[R[hB
*/

static	int zx_tx_at( HZXC hz, LPCSTR ps, DWORD cch )
{
	assert( h_valid( hz ) );
	assert( NULL != ps );
	assert( cch );
					/* cm[ 2 ] */
	assert( 2 + sizeof ( hz->txat.txat.ds ) > cch );

{
	LPSTR	pD;
	LPSTR	p1;

	pD = hz->txat.txat.cm;
	p1 = cch + pD;
	while  ( pD < p1 )
	{
		*pD++ = *ps++;
	}
}

					/* frame type, frame id. */
	return fr_tx( hz, &hz->txat, 2 + cch );
}

/*//////////////////////////////////////////////////////////////////////
0x10
ZigBeeMv𑗐M܂B
in	hn	m[hnhB
	ps	M̃AhXB
	cch	MB
ret	G[R[hB
*/

static	int zn_tx_zb( HZXN hn, LPCSTR ps, DWORD cch )
{
	assert( hn_valid( hn ) );
	assert( NULL != ps );
	assert( cch );
	assert( sizeof ( hn->txzb.txzb.ds ) > cch );

{
	LPSTR	pD;
	LPSTR	p1;

	pD = hn->txzb.txzb.ds;
	p1 = cch + pD;
	while  ( pD < p1 )
	{
		*pD++ = *ps++;
	}
}

					/* frame type, frame id, */
					/* destination address, */
					/* 16-bit destination address, */
					/* broadcast range, option. */
	return fr_tx( hn->hc, &hn->txzb, 2 + 8 + 2 + 2 + cch );
}

/*//////////////////////////////////////////////////////////////////////
0x17
uATR}hv𑗐M܂B
in	hn	m[hnhB
	ps	R}h̃AhXB
	cch	R}hB
ret	G[R[hB
*/

static	int zn_tx_rat( HZXN hn, LPCSTR ps, DWORD cch )
{
	assert( hn_valid( hn ) );
	assert( NULL != ps );
	assert( cch );
	assert( sizeof ( hn->txrat.txrat.ds ) > cch );

{
	LPSTR	pD;
	LPSTR	p1;

	pD = hn->txrat.txrat.cm;
	p1 = cch + pD;
	while  ( pD < p1 )
	{
		*pD++ = *ps++;
	}
}

					/* frame type, frame id, */
					/* destination address, */
					/* 16-bit destination address, */
					/* option. */
	return fr_tx( hn->hc, &hn->txrat, 2 + 8 + 2 + 1 + cch );
}

/*//////////////////////////////////////////////////////////////////////
Pt[M܂B
in	hz	nhB
	prx	Mt[i[obt@̃AhXB
ret	G[R[hB
TODO
SRI[o[bvĂ܂B
*/

static	int fr_rx( HZXC hz, LPXBAF prx )
{
	DWORD	cbX;	/* received bytes. */
	DWORD	cb;	/* frame data bytes. */

	assert( h_valid( hz ) );
	assert( NULL != prx );

	( void )ResetEvent( hz->oComm.hEvent );

	if ( ! ReadFile(
			hz->hComm,
			prx,
					/* delimiter + bytes. */
			sizeof ( TXBAFH0 ),
			&cbX,
			&hz->oComm
			) )
	{
		if ( ERROR_IO_PENDING != GetLastError() )
		{
#ifdef	_DEBUG	/*[*/
			s_v.ce.c0ReadFile++;
#endif	/*]*/

			return ZXE_RX;
		}
	}

	if ( ! GetOverlappedResult(
			hz->hComm,
			&hz->oComm,
			&cbX,
			TRUE
			) )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.c0GetOverlappedResult++;
#endif	/*]*/

		return ZXE_SYS;
	}

	if ( sizeof ( TXBAFH0 ) > cbX )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.cHeadCb++;
#endif	/*]*/

		return ZXE_COMM;
	}

	if ( XB_CH_DELIM != prx->hd0.chD )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.cDelimiter++;
#endif	/*]*/

		return ZXE_RX;
	}

	cb = PEEK_W( &prx->hd0.CB );

	( void )ResetEvent( hz->oComm.hEvent );

	if ( ! ReadFile(
			hz->hComm,
			&prx->hd.ft,
			1 + cb,		/* room for checksum. */
			&cbX,
			&hz->oComm
			) )
	{
		if ( ERROR_IO_PENDING != GetLastError() )
		{
#ifdef	_DEBUG	/*[*/
			s_v.ce.c1ReadFile++;
#endif	/*]*/

			return ZXE_RX;
		}
	}

	if ( ! GetOverlappedResult(
			hz->hComm,
			&hz->oComm,
			&cbX,
			TRUE
			) )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.c1GetOverlappedResult++;
#endif	/*]*/

		return ZXE_SYS;
	}

#ifdef	BF_CAPT_FRAME	/*[*/
	if ( CAPT_MAX_RX > g_cap.cRx )
	{
		g_cap.aRx[ g_cap.cRx ].tC = GetTickCount();
		( void )memcpy(
				g_cap.aRx[ g_cap.cRx ].fr,
				prx,
				1 + 2 + 1 + cb
				);
		g_cap.cRx++;
	}
#endif	/*]*/

	if ( cb >= cbX )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.cBodyCb++;
#endif	/*]*/

		return ZXE_COMM;
	}

#ifndef	BFL_NO_SUM_CHECK	/*[*/
{
	BYTE	bSum;	/* checksum. */
	DWORD	ii;	/* iterator. */

	bSum = ( BYTE )-1;
	for ( ii = 0; ii < cb; ii++ )
	{
		bSum = ( BYTE )( bSum - ii[ &prx->hd.ft ] );
	}

	if ( bSum != ii[ &prx->hd.ft ] )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.cChecksum++;
#endif	/*]*/

		return ZXE_SUM;
	}
}
#endif	/*]*/

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
Pt[M܂B
in	hz	nhB
	prx	Mt[i[obt@̃AhXB
ret	G[R[hB
TODO
XbhEEE
*/

static	int zx_rx( HZXC hz, LPXBAF prx )
{
	int	ri;	/* result. */

	assert( h_valid( hz ) );
	assert( NULL != prx );

	ri = fr_rx( hz, prx );
	while ( ZXR_OK == ri )
	{
		switch ( prx->hd.ft )
		{
		default:
			/*
			// Ă܂B
			*/
#ifdef	_DEBUG	/*[*/
			s_v.ce.cUnexpected++;
#endif	/*]*/
			break;

		case XB_FT_RX_MST:
			/*
			// ꉞXV܂gpłB
			*/
			hz->stModem = prx->rxmst.st;

#ifdef	_DEBUG	/*[*/
			s_v.ce.cModemStatus++;
#endif	/*]*/

			/*
			// TODO
			//	m[h\ωf
			*/

			break;

		case XB_FT_RX_AT:
		case XB_FT_RX_ZB_ST:
		case XB_FT_RX_ZB:
		case XB_FT_RX_RAT:
			/*
			// NCAgɖ߂܂B
			*/

			return ZXR_OK;
		}

		ri = fr_rx( hz, prx );
	}

	hz->fError = TRUE;

	return ri;
}

/*//////////////////////////////////////////////////////////////////////
Pt[M܂B
in	hz	nhB
	prx	Mt[i[obt@̃AhXB
	ft	̃t[^Cvǂݎ܂œǂ݊Ă܂B
	fid	̃t[IDǂݎ܂œǂ݊Ă܂B
ret	G[R[hB
*/

static	int zx_rx_fd( HZXC hz, LPXBAF prx, BYTE ft )
{
	int	ri;	/* result. */

	for ( ; ; )
	{
		ri = zx_rx( hz, prx );
		if ( ZXR_OK != ri )
		{
			return ri;
		}

		if ( ft == prx->hd.ft || FID_CUR() == prx->hd.fid )
		{
			break;
		}

#ifdef	_DEBUG	/*[*/
		if ( ft != prx->hd.ft )
		{
			s_v.ce.cFType++;
		}
		if ( FID_CUR() != prx->hd.fid )
		{
			s_v.ce.cFId++;
		}
#endif	/*]*/
	}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
ZigBeeMpPbgPt[M܂B
in	hz	nhB
	prx	Mt[i[obt@̃AhXB
ret	G[R[hB
*/

static	int zn_rx_zbpk( HZXN hn, LPXBAF prx )
{
	int	ri;	/* result. */

	for ( ; ; )
	{
		ri = zx_rx( hn->hc, prx );
		if ( ZXR_OK != ri )
		{
			return ri;
		}

		if ( XB_FT_RX_ZB == prx->rxzb.ft
				&& hn->SH == prx->rxzb.SH
				&& hn->SL == prx->rxzb.SL
				)
		{
			break;
		}

#ifdef	_DEBUG	/*[*/
		if ( XB_FT_RX_ZB != prx->rxzb.ft )
		{
			s_v.ce.cZbPkFType++;
		}
		if ( hn->SH != prx->rxzb.SH
				|| hn->SL != prx->rxzb.SL
				)
		{
			s_v.ce.cZbPkAddr++;
		}
#endif	/*]*/
	}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
M^CAEg܂ŗṽt[M݂܂B
in	hz	nhB
	prx	t[󂯎obt@̃AhXB
	nMax	󂯎t[B
ret	Mt[B
obt@TCYsňȂɑ΂Ă͉܂B
ʐM|[gMobt@ɂ͈Ȃf[^cꂽ܂܂
Ȃ܂B
*/

static	DWORD zx_rx_n( HZXC hz, LPXBAF prx, DWORD nMax )
{
	DWORD	nF;	/* # of received frames. */
	int	ri;	/* result. */

	assert( h_valid( hz ) );
	assert( NULL != prx );

	for ( nF = 0; nF < nMax; nF++ )
	{
		ri = zx_rx( hz, prx++ );
		if ( ZXR_OK != ri )
		{
			break;
		}
	}

	return nF;
}

/*//////////////////////////////////////////////////////////////////////
XBeeG[ϊ܂B
in	st	XBeeG[B
ret	G[R[hB
*/

static	int zxe_from_atst( BYTE st )
{
	switch ( st )
	{
	case XB_AT_OK:
		break;
	default:

		/* fall through. */

	case XB_AT_ERR:
		return ZXE_XB;
	case XB_AT_INV_CMD:
		return ZXE_AT;
	case XB_AT_INV_PAR:
		return ZXE_ARG;
	case XB_AT_TX_FAIL:
		return ZXE_TX;
	}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
ATR}hs܂B
in	hz	nhB
	prx	ATR}hi[obt@̃AhXB
	pszC	R}h̃AhXB
	cchC	R}hB
out	*prx	ATR}hB
ret	G[R[hB
I/OubLOΏۂłB
*/

static	int zx_ex_at( HZXC hz, LPXBAF prx, LPCSTR pszC, DWORD cchC )
{
	int	ri;	/* result. */

	assert( h_valid( hz ) );
	assert( NULL != pszC );
	assert( 2 <= cchC );

	/*
	// reset status.
	*/

	hz->stAT = XB_AT_OK;

	/*
	// enter i/o blocking.
	*/

	( void )WaitForSingleObject( hz->hxComm, INFINITE );

	/*
	// tx command.
	*/

	ri = zx_tx_at( hz, pszC, cchC );
	if ( ZXR_OK == ri )
	{
		/*
		// rx response.
		*/

		ri = zx_rx_fd( hz, prx, XB_FT_RX_AT );
	}

	/*
	// leave i/o blocking.
	*/

	( void )ReleaseMutex( hz->hxComm );

	if ( ZXR_OK != ri )
	{
		return ri;
	}

	/*
	// save AT command status.
	*/

	hz->stAT = prx->rxat.st;

	/*
	// verify AT command status.
	*/

	if ( XB_AT_OK != prx->rxat.st )
	{
		return zxe_from_atst( prx->rxat.st );
	}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
ATR}hs܂B
in	hz	nhB
	pszC	R}h̃AhXB
	cchC	R}hB
	pb	ATR}h󂯎obt@̃AhXB
	cb	i[\ȃoCg
	pcb	i[ꂽoCg󂯎obt@̃AhXB
out	*pcb	i[ꂽoCgB
ret	G[R[hB
*/

static	int zx_at( HZXC hz, LPCSTR pszC, DWORD cchC, LPBYTE pb, DWORD cb, LPDWORD pcb )
{
	TXBAF	rx;	/* response frame. */
	int	ri;	/* result. */

	assert( h_valid( hz ) );
	assert( NULL != pszC );
	assert( 2 <= cchC );

	/*
	// AT command.
	*/

	ri = zx_ex_at( hz, &rx, pszC, cchC );
	if ( ZXR_OK != ri )
	{
		return ri;
	}

		/*
		// frame type,
		// frame id,
		// command,
		// status,
		// SOMETHING.
		*/

#undef	CB_MIN
#define	CB_MIN	( 1 + 1 + 2 + 1 + 1 )

{
	DWORD	cbF;	/* bytes of rx frame data. */

	/*
	// ߂oCg
	*/

	cbF = PEEK_W( &rx.rxat.CB );
	if ( CB_MIN > cbF || NULL == pb || 1 > cb )
	{
		return ZXR_OK;
	}

{
	LPBYTE	pbS;	/* source. */
	DWORD	ib;	/* iterator. */

	/*
	// prepare output.
	*/

	pbS = rx.rxat.ds;
					/* frame type, frame id, */
	cbF -= 1 + 1 + 2 + 1;		/* command, status. */
	for ( ib = 0; ib < cbF && ib < cb; ib++ )
	{
		*pb++ = *pbS++;
	}

	/*
	// report copied bytes if needed.
	*/

	if ( NULL != pcb )
	{
		*pcb = ib;
	}
}
}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
ԂATR}hs܂B
in	hz	nhB
	pszC	R}h̃AhXB
	cchC	R}hB
	pszR	i[obt@̃AhXB
	cchR	NUL^[~l[^܂ފi[\ȕB
	pcchR	i[ꂽi[obt@̃AhXB
out	*pcchR	i[ꂽB
ret	G[R[hB
*/

static	int zx_at_rs( HZXC hz, LPCSTR pszC, DWORD cchC, LPSTR pszR, DWORD cchR, LPDWORD pcchR )
{
	TXBAF	rx;	/* response frame. */
	int	ri;	/* result. */

	assert( h_valid( hz ) );
	assert( NULL != pszC );
	assert( 2 <= cchC );
	assert( NULL != pszR );
	assert( cchR );

	/*
	// AT command.
	*/

	ri = zx_ex_at( hz, &rx, pszC, cchC );
	if ( ZXR_OK != ri )
	{
		return ri;
	}

		/*
		// frame type,
		// frame id,
		// command,
		// status,
		// STRING.
		*/

#undef	CB_MIN
#define	CB_MIN	( 1 + 1 + 2 + 1 + 1 )

{
	DWORD	cbF;	/* bytes of rx frame data. */

	/*
	// ߂oCg
	*/

	cbF = PEEK_W( &rx.rxat.CB );
	if ( CB_MIN > cbF )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.cAtRSCb++;
#endif	/*]*/

		return ZXE_COMM;
	}

{
	LPCSTR	pszS;	/* source. */
	DWORD	cch;	/* iterator. */

	/*
	// prepare output.
	*/

	cchR--;
	pszS = ( LPCSTR )rx.rxat.ds;
					/* frame type, frame id, */
	cbF -= 1 + 1 + 2 + 1;		/* command, status. */
	for ( cch = 0; cch < cchR && cch < cbF; cch++ )
	{
		pszR[ cch ] = ( char )rx.rxat.ds[ cch ];
	}
	pszR[ cch ] = EOS;

	/*
	// report copied bytes if needed.
	*/

	if ( NULL != pcchR )
	{
		*pcchR = cch;
	}
}
}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
ATNDłB
*/

/*//////////////////////////////////////////////////////////////////////
P̃m[hiATNDjfR[h܂B
in	pzn	fR[hʂi[obt@̃AhXB
	prx	ATNDt[B
out	*pzn	fR[hʁB
*/

static	void nd_dec( HZXN pzn, LPXBAF prx )
{
	assert( NULL != prx );
	assert( NULL != pzn );

	pzn->my = PEEK_W( &prx->rxatnd.my );
	pzn->sh = PEEK_D( &prx->rxatnd.sh );
	pzn->sl = PEEK_D( &prx->rxatnd.sl );

	pzn->MY = prx->rxatnd.my;
	pzn->SH = prx->rxatnd.sh;
	pzn->SL = prx->rxatnd.sl;

{
	LPCSTR	pszS;	/* ni source. */
	LPSTR	pszD;	/* ni destination. */
	UINT	cch;	/* */

	/* network identifier. */

	pszS = prx->rxatnd.ni;
	pszD = pzn->ni;
	for ( cch = 0; cch < XB_CCH_MAX_NI; cch++ )
	{
		*pszD++ = *pszS;
		if ( ! *pszS++ )
		{
			break;
		}
	}
	*pszD = EOS;

	/* parent network address. */

	pzn->PA = *( LPWORD )pszS;
	pszS += 2;

	/* device type. */

	pzn->dt = *pszS++;

	/* status. */

	pzn->st = *pszS++;

	/* profile id. */

	pzn->PI = *( LPWORD )pszS;
	pszS += 2;

	/* factory id. */

	pzn->FI = *( LPWORD )pszS;
}
}

/*//////////////////////////////////////////////////////////////////////
ZigBeeMvt[̈ꕔ쐬܂B
in	pzn	쐬B
out	*pzn->txzb
		t[̈ꕔB
nd_dečŌĂяo܂B
*/

static	_inline void zn_txzb_bld( HZXN pzn )
{
	pzn->txzb.txzb.chD = XB_CH_DELIM;
	pzn->txzb.txzb.ft = XB_FT_TX_ZB;
	pzn->txzb.txzb.DH = pzn->SH;
	pzn->txzb.txzb.DL = pzn->SL;
	pzn->txzb.txzb.D16 = pzn->MY;
	pzn->txzb.txzb.bcr = 0;		/* őzbvl */
	pzn->txzb.txzb.opt = 0;
}

/*//////////////////////////////////////////////////////////////////////
uATR}hvt[̈ꕔ쐬܂B
in	pzn	쐬B
out	*pzn->txrat
		t[̈ꕔB
nd_dečŌĂяo܂B
*/

static	_inline void zn_txrat_bld( HZXN pzn )
{
	pzn->txrat.txrat.chD = XB_CH_DELIM;
	pzn->txrat.txrat.ft = XB_FT_TX_RAT;
	pzn->txrat.txrat.DH = pzn->SH;
	pzn->txrat.txrat.DL = pzn->SL;
	pzn->txrat.txrat.D16 = pzn->MY;
	pzn->txrat.txrat.opt = 0x02;	/* ύXL */
}

/*//////////////////////////////////////////////////////////////////////
m[hiATNDjfR[h܂B
in	hz	nhB
	prx	ATNDt[̔zB
	nN	fR[hm[hB
out	pzn[]	fR[hʁB
*/

static	void nd_dec_n( HZXC hz, LPXBAF prx, UINT nN )
{
	HZXN	pzn;	/* node. */
	UINT	iN;	/* node iterator. */

	assert( NULL != prx );
	assert( hz_valid( hz ) );

	pzn = hz->aN;
	for ( iN = 0; iN < nN; iN++ )
	{
		pzn->hc = hz;
		pzn->ix = iN;

		nd_dec( pzn, prx++ );

		zn_txzb_bld( pzn );
		zn_txrat_bld( pzn );

		pzn++;
	}
}

/*//////////////////////////////////////////////////////////////////////
PANɎQĂR[fBl[^䉺̃m[h񋓂܂B
in	hz	nhB
ret	PANɎQĂm[hB
	̏ꍇ̓G[R[hB
ATNDR}h𔭍sĉfR[h܂B
{֐͐\bPʂ̎ԂKvƂ܂B
I/OubLOΏۂłB
*/

int ZcEnum( HZXC hz )
{
			/* receive frames. */
	TXBAF	arx[ ZXC_MAX_DEVS ];
	UINT	nN;	/* # of peripheral devices. */
	int	ri;	/* result */

	if ( ! h_valid( hz ) )
	{
		return ZXE_HANDLE;
	}

	nN = 0;

	/*
	// enter i/o blocking.
	*/

	( void )WaitForSingleObject( hz->hxComm, INFINITE );

#if	TRUE	/*[*/

	/*
	// modify timeout.
	*/

	if ( tmo_set( hz, CMS_TMO_ND ) )
	{
		ri = ZXR_OK;
	}
	else
	{
		ri = ZXE_COMM;
	}

#endif	/*]*/

	if ( ZXR_OK == ri )
	{
		/*
		// send ATND command.
		*/

		ri = zx_tx_at( hz, "ND", 2 );
	}

	if ( ZXR_OK == ri )
	{
		/*
		// receive ATND command response.
		*/

		nN = zx_rx_n( hz, arx, LENGTH_OF( arx ) );
		assert( LENGTH_OF( hz->aN ) >= nN );

		/*
		// PANɑ吨QĂꍇ
		*/

		( void )PurgeComm( hz->hComm, PURGE_RXCLEAR );
	}

#if	TRUE	/*[*/

	/*
	// restore timeout.
	*/

	if ( ! tmo_set( hz, hz->cmsTmo ) )
	{
		if ( ZXR_OK == ri )
		{
			ri = ZXE_COMM;
		}
	}

#endif	/*]*/

	/*
	// leave i/o blocking.
	*/

	( void )ReleaseMutex( hz->hxComm );

	if ( ZXR_OK != ri )
	{
		return 0;
	}

	/*
	// decode node information.
	*/

	nd_dec_n( hz, arx, nN );

	return hz->nN = nN;
}

/*//////////////////////////////////////////////////////////////////////
ʐM|[gɐڑꂽfoCXniǂ𔻒肵܂B
in	hz	nhB
	ni	lbg[NʎqB
ret	FALSE	nił͂܂B
	else	niłB
*/

static	_inline BOOL zx_is( HZXC hz, LPCSTR ni )
{
	if ( ! hz_valid( hz ) )
	{
		return FALSE;
	}

	return ! strcmp( hz->ni, ni );
}

/*//////////////////////////////////////////////////////////////////////
ʐM|[gɐڑꂽfoCXR[fBl[^ǂ𔻒肵܂B
in	hz
ret	FALSE	R[fBl[^ł͂܂B
	else	R[fBl[^łB
*/

BOOL ZxIsZc( HZXC hz )
{
	return zx_is( hz, s_szZc001 );
}

/*//////////////////////////////////////////////////////////////////////
w̃m[h
niǂ𔻒肵܂B
in	hn	m[hnhB
	ni	lbg[NʎqB
ret	FALSE	nił͂܂B
	else	niłB
*/

static	_inline BOOL zn_is( HZXN hn, LPCSTR ni )
{
	if ( ! hn_valid( hn ) )
	{
		return FALSE;
	}

	return ! strcmp( hn->ni, ni );
}

/*//////////////////////////////////////////////////////////////////////
w̃m[hCPI-ZD132ǂ𔻒肵܂B
in	hn	m[hnhB
ret	FALSE	CPI-ZD132ł͂܂B
	else	CPI-ZD132łB
*/

BOOL ZnIsZd132( HZXN hn )
{
	return zn_is( hn, s_szZd132 );
}

/*//////////////////////////////////////////////////////////////////////
w̃m[hCPI-ZD232ǂ𔻒肵܂B
in	hn	m[hnhB
ret	FALSE	CPI-ZD232ł͂܂B
	else	CPI-ZD232łB
*/

BOOL ZnIsZd232( HZXN hn )
{
	return zn_is( hn, s_szZd232 );
}

/*//////////////////////////////////////////////////////////////////////
w̃m[hCPI-ZD332ǂ𔻒肵܂B
in	hn	m[hnhB
ret	FALSE	CPI-ZD332ł͂܂B
	else	CPI-ZD332łB
*/

BOOL ZnIsZd332( HZXN hn )
{
	return zn_is( hn, s_szZd332 );
}

/*//////////////////////////////////////////////////////////////////////
*/

typedef	BOOL ( *TFN90VALID )( HZXN hn, LPXBAF prx );

/*//////////////////////////////////////////////////////////////////////
ZigBeeMXe[^XM
in	hn	m[hnhB
	prx	ZigBeeMXe[^Xi[A
		AZigBeeMpPbgi[obt@̃AhXB
out	prx	ZigBeeMpPbgB
ret	G[R[hB
*/

static	int zb_st( HZXN hn, LPXBAF prx, TFN90VALID pfn )
{
	/*
	// save ZigBee transmit status.
	*/

	hn->nRetry = prx->rxzbst.nRetry;
	hn->stDelivery = prx->rxzbst.stDelivery;
	hn->stDiscovery = prx->rxzbst.stDiscovery;

	/*
	// verify ZigBee transmit status.
	*/

	if ( prx->rxzbst.stDelivery )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.cZbSt++;
#endif	/*]*/

		/*
		// ZigBeeMpPbg͎MȂ͂B
		*/

		return ZXE_TX;
	}

	/*
	// receive ZigBee receive packet.
	*/

	for ( ; ; )
	{
		int	ri;

		ri = zn_rx_zbpk( hn, prx );
		if ( ZXR_OK != ri )
		{
			return ri;
		}

		if ( ( *pfn )( hn, prx ) )
		{
			break;
		}

		/*
		// ZigBeeMpPbg̏ꍇ
		// ɍȂ͔̂j܂B
		*/
	}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
ZigBeeMXe[^XMOZigBee receive packetMꍇ
in	hn	m[hnhB
ret	G[R[hB
*/

static	int zb_pk( HZXN hn )
{
	TXBAF	rx;	/* ZigBee transmit status. */
	int	ri;	/* result. */

	/*
	// receive ZigBee transmit status.
	*/

	ri = zx_rx_fd( hn->hc, &rx, XB_FT_RX_ZB_ST );
	if ( ZXR_OK != ri )
	{
		return ri;
	}

	/*
	// save ZigBee transmit status.
	*/

	hn->nRetry = rx.rxzbst.nRetry;
	hn->stDelivery = rx.rxzbst.stDelivery;
	hn->stDiscovery = rx.rxzbst.stDiscovery;

	/*
	// verify ZigBee transmit status.
	*/

	assert( XB_DV_SUCCESS == rx.rxzbst.stDelivery );

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
ZigBeeMXe[^XM
ZigBeeMpPbgM
in	hn	m[hnhB
	prx	ZigBeeMpPbgi[obt@̃AhXB
out	*prx	ZigBeeMpPbgB
ret	G[R[hB
ZigBeeMXe[^XOZigBeeMpPbgMꍇ܂B
*/

static	int zb_rx( HZXN hn, LPXBAF prx, TFN90VALID pfn )
{
	int	ri;	/* result. */

	assert( hn_valid( hn ) );
	assert( NULL != prx );

	for ( ; ; )
	{
		ri = zx_rx( hn->hc, prx );
		if ( ZXR_OK != ri )
		{
			break;
		}

		if ( XB_FT_RX_ZB_ST == prx->hd.ft )
		{
			if ( prx->rxzbst.fid != FID_CUR() )
			{
#ifdef	_DEBUG	/*[*/
				s_v.ce.cZbFId++;
#endif	/*]*/

				continue;
			}

			ri = zb_st( hn, prx, pfn );
			break;
		}
		else if ( XB_FT_RX_ZB == prx->hd.ft )
		{
			if ( prx->rxzb.SH != hn->SH
					|| prx->rxzb.SL != hn->SL
					)
			{
#ifdef	_DEBUG	/*[*/
				s_v.ce.cZbAddr++;
#endif	/*]*/

				continue;
			}

					/* MpPbgÓmF */
			if ( ! ( *pfn )( hn, prx ) )
			{
				continue;
			}

#ifdef	_DEBUG	/*[*/
			s_v.ce.cReversed++;
#endif	/*]*/
			ri = zb_pk( hn );
			break;
		}
#ifdef	_DEBUG	/*[*/
		else
		{
			s_v.ce.cZbFType++;
		}
#endif	/*]*/
	}

	return ri;
}

/*//////////////////////////////////////////////////////////////////////
ZigBeeR}hsB
o ZigBeeMvM
o ZigBeeMXe[^XM
o ZigBeeMpPbgM
in	hn	m[hnhB
	pszC	R}h̃AhXB
	cchC	R}hB
ret	G[R[hB
I/OubLOΏۂłB
*/

static	int zn_ex_zb( HZXN hn, LPXBAF prx, LPCSTR pszC, DWORD cchC, TFN90VALID pfn )
{
	int	ri;	/* result. */

	assert( NULL != prx );
	assert( NULL != pszC );
	assert( 2 <= cchC );

	/*
	// confirm arguments.
	*/

	if ( ! hn_valid( hn ) )
	{
		return ZXE_HANDLE;
	}

	/*
	// reset status.
	*/

	hn->nRetry = hn->stDelivery = hn->stDiscovery = 0;

	/*
	// enter i/o blocking.
	*/

	( void )WaitForSingleObject( hn->hc->hxComm, INFINITE );

	/*
	// ZigBee transmit request.
	// send command.
	*/

	ri = zn_tx_zb( hn, pszC, cchC );
	if ( ZXR_OK == ri )
	{
		/*
		// receive ZigBee transmit status.
		*/

		ri = zb_rx( hn, prx, pfn );
	}

	/*
	// leave i/o blocking.
	*/

	( void )ReleaseMutex( hn->hc->hxComm );

	if ( ZXR_OK != ri )
	{
		return ri;
	}

	/*
	// prepare return value.
	*/

	return ( int )strtoul( prx->rxzb.ds, NULL, 16 );
}

/*//////////////////////////////////////////////////////////////////////
X|XG[R[ĥ݂ZigBeeR}hsB
in	hn	m[hnhB
	pszC	R}h̃AhXB
	cchC	R}hB
ret	G[R[hB
*/

		/*
		// frame type,
		// source address,
		// 16-bit source address,
		// option,
		// RETURN PACKET
		//	ee<CR>
		*/

#undef	CB_FIX
#define	CB_FIX	( 1 + 8 + 2 + 1 + 3 )

static	BOOL zn_zb_rn_val( HZXN hn, LPXBAF prx )
{
	assert( NULL != hn );
	assert( NULL != prx );
	assert( XB_FT_RX_ZB == prx->hd.ft );

	( void )hn;

{
	DWORD	cbF;	/* bytes of rx frame data. */

	/*
	// ߂oCg
	*/

	cbF = PEEK_W( &prx->rxzb.CB );
	if ( CB_FIX != cbF )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.cZbRNCb++;
#endif	/*]*/

		return FALSE;
	}

	return TRUE;
}
}

static	int zn_zb_rn( HZXN hn, LPCSTR pszC, DWORD cchC )
{
	TXBAF	rx;	/* response frame. */
	int	ri;	/* result. */

	/*
	// peripheral command.
	*/

	ri = zn_ex_zb( hn, &rx, pszC, cchC, zn_zb_rn_val );
	if ( ZXR_OK != ri )
	{
		return ri;
	}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
X|XG[R[hƂWrbgl𔺂ZigBeeR}hsB
in	hn	m[hnhB
	pszC	R}h̃AhXB
	cchC	R}hB
	pV	Wrbgli[obt@̃AhXB
ret	G[R[hB
*/

		/*
		// frame type,
		// source address,
		// 16-bit source address,
		// option,
		// RETURN PACKET
		//	ee v<CR>
		//		ee	16iQ̃G[R[h
		//		v	16iPȏ̖߂l
		*/

#undef	CB_MIN
#define	CB_MIN	( 1 + 8 + 2 + 1 + 5 )

static	BOOL zn_zb_rb_val( HZXN hn, LPXBAF prx )
{
	assert( NULL != hn );
	assert( NULL != prx );
	assert( XB_FT_RX_ZB == prx->hd.ft );

	( void )hn;

{
	DWORD	cbF;	/* bytes of rx frame data. */

	/*
	// ߂oCg
	*/

	cbF = PEEK_W( &prx->rxzb.CB );
	if ( CB_MIN > cbF )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.cZbRBCb++;
#endif	/*]*/

		return FALSE;
	}

	return TRUE;
}
}

static	int zn_zb_rb( HZXN hn, LPCSTR pszC, DWORD cchC, LPBYTE pV )
{
	TXBAF	rx;	/* response frame. */
	int	ri;	/* result. */

	assert( NULL != pV );

	/*
	// peripheral command.
	*/

	ri = zn_ex_zb( hn, &rx, pszC, cchC, zn_zb_rb_val );
	if ( ZXR_OK != ri )
	{
		return ri;
	}

	/*
	// prepare output.
	*/

	*pV = ( BYTE )strtoul( 3 + rx.rxzb.ds, NULL, 16 );

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
X|XG[R[hƕ𔺂ZigBeeR}hsB
in	hn	m[hnhB
	pszC	R}h̃AhXB
	cchC	R}hB
	pszR	擾i[obt@̃AhXB
	cchR	pszR̕B
	pcchR	i[i[obt@̃AhXB
out	*pcchR	i[B
ret	G[R[hB
*/

		/*
		// frame type,
		// source address,
		// 16-bit source address,
		// option,
		// RETURN PACKET
		//	ee s<CR>
		//		ee	16iQ̃G[R[h
		//		s	Pȏ̖߂l
		*/

#undef	CB_MIN
#define	CB_MIN	( 1 + 8 + 2 + 1 + 5 )

static	BOOL zn_zb_rs_val( HZXN hn, LPXBAF prx )
{
	assert( NULL != hn );
	assert( NULL != prx );
	assert( XB_FT_RX_ZB == prx->hd.ft );

	( void )hn;

{
	DWORD	cbF;	/* bytes of rx frame data. */

	/*
	// ߂oCg
	*/

	cbF = PEEK_W( &prx->rxzb.CB );
	if ( CB_MIN > cbF )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.cZbRSCb++;
#endif	/*]*/

		return FALSE;
	}

	return TRUE;
}
}

static	int zn_zb_rs( HZXN hn, LPCSTR pszC, DWORD cchC, LPSTR pszR, DWORD cchR, LPDWORD pcchR )
{
	TXBAF	rx;	/* response frame. */
	int	ri;	/* result. */

	assert( NULL != pszR );
	assert( cchR );

	/*
	// peripheral command.
	*/

	ri = zn_ex_zb( hn, &rx, pszC, cchC, zn_zb_rs_val );
	if ( ZXR_OK != ri )
	{
		return ri;
	}

{
	LPCSTR	psz;
	DWORD	cch;

	/*
	// prepare output.
	*/

	psz = 3 + rx.rxzb.ds;		/* skip return code. */
	for ( cch = 1; cch < cchR && CR != *psz; cch++ )
	{
		*pszR++ = *psz++;
	}
	*pszR = EOS;

	if ( NULL != pcchR )
	{
		*pcchR = cch - 1;
	}
}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
uATR}hsB
in	hn	m[hnhB
	prx	uATR}hi[obt@̃AhXB
	pszC	R}h̃AhXB
	cchC	R}hB
out	*prx	uATR}hB
ret	G[R[hB
I/OubLOΏۂłB
*/

static	int zn_ex_rat( HZXN hn, LPXBAF prx, LPCSTR pszC, DWORD cchC )
{
	int	ri;	/* result. */

	assert( NULL != prx );
	assert( NULL != pszC );
	assert( 2 <= cchC );

	/*
	// confirm arguments.
	*/

	if ( ! hn_valid( hn ) )
	{
		return ZXE_HANDLE;
	}

	/*
	// reset status.
	*/

	hn->stRAT = XB_AT_OK;

	/*
	// enter i/o blocking.
	*/

	( void )WaitForSingleObject( hn->hc->hxComm, INFINITE );

	/*
	// send command.
	*/

	ri = zn_tx_rat( hn, pszC, cchC );
	if ( ZXR_OK == ri )
	{
		/*
		// receive remote AT command response.
		*/

		ri = zx_rx_fd( hn->hc, prx, XB_FT_RX_RAT );
	}

	/*
	// leave i/o blocking.
	*/

	( void )ReleaseMutex( hn->hc->hxComm );

	if ( ZXR_OK != ri )
	{
		return ri;
	}

	/*
	// save remote AT command status.
	*/

	hn->stRAT = prx->rxrat.st;

	/*
	// verify AT command status.
	*/

	if ( XB_AT_OK != prx->rxrat.st )
	{
		return zxe_from_atst( prx->rxrat.st );
	}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
Wrbg̏o͒l𔺂uATR}hsB
in	hn	m[hnhB
	pszC	R}h̃AhXB
	cchC	R}hB
	pV	oCgli[obt@̃AhXB
ret	G[R[hB
*/

static	int zn_rat_rb( HZXN hn, LPCSTR pszC, DWORD cchC, LPBYTE pV )
{
	TXBAF	rx;	/* remote AT response. */
	int	ri;	/* result. */

	/*
	// remote AT command.
	*/

	ri = zn_ex_rat( hn, &rx, pszC, cchC );
	if ( ZXR_OK != ri )
	{
		return ri;
	}

		/*
		// frame type,
		// frame id,
		// source address,
		// 16-bit source address,
		// command,
		// status,
		// RETURN BYTE.
		*/

#undef	CB_MIN
#define	CB_MIN	( 1 + 1 + 8 + 2 + 2 + 1 + 1 )

{
	DWORD	cbF;	/* bytes of rx frame data. */

	/*
	// ߂oCg
	*/

	cbF = PEEK_W( &rx.rxrat.CB );
	if ( CB_MIN > cbF )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.cRatRBCb++;
#endif	/*]*/

		return ZXE_COMM;
	}
}

	/*
	// prepare output.
	*/

	*pV = *rx.rxrat.ds;

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
G[R[hɑΉbZ[W擾B
in	iErr	G[R[hB
ret	G[R[hӖ镶̃AhXB
*/

LPCTSTR ZdErrStr( int iErr )
{
	switch ( iErr )
	{
	default:
		break;
	case ZXE_AT:
		return _T( " AT R}h" );
	case ZXE_XB:
		return _T( "XB G[" );
	case ZXE_SUM:
		return _T( "API t[`FbNTG[" );
	case ZXE_SYS:
		return _T( "VXeG[" );
	case ZXE_LOCK:
		return _T( "I/O r^CAEg" );
	case ZXE_ARG:
		return _T( "Ȉ" );
	case ZXE_RX:
		return _T( "M^CAEg" );
	case ZXE_TX:
		return _T( "MG[" );
	case ZXE_COMM:
		return _T( "ʐMG[" );
	case ZXE_SEL:
		return _T( "ȃfoCXԍ" );
	case ZXE_HANDLE:
		return _T( "ȃnh" );
	case ZXR_OK:
		return _T( "I" );
	case ZXR_ARG:
		return _T( "s" );
	case ZXR_PORT:
		return _T( "ȃ|[g" );
	case ZXR_NO_DATA:
		return _T( "gKĂȂ" );
	case ZXR_FREQ:
		return _T( "ȃtB^Ԋu" );
	case ZXR_MODE:
		return _T( "ȊĎ[h" );
	case ZXR_TIMEOUT:
		return _T( "WDT^CAEg" );
	case ZXR_COMMAND:
		return _T( "ȃR}h" );
	}

	return _T( "sȃG[" );
}

/*//////////////////////////////////////////////////////////////////////
QER}hsB
in	hn	m[hnhB
ret	ŌɔG[̃R[hB
*/

int ZdErrGet( HZXN hn )
{
DSCA( s_sz,	"QE\r" );

	return zn_zb_rn( hn, s_sz, sizeof ( s_sz ) - 1 );
}

/*//////////////////////////////////////////////////////////////////////
QIR}hsB
in	hn	m[hnhB
	psz	21ȏ̃̕AhXB
out	psz	foCXB
ret	G[R[hB
*/

int ZdDevGet( HZXN hn, LPSTR psz, DWORD cch )
{
DSCA( s_sz,	"QI\r" );

	return zn_zb_rs( hn, s_sz, sizeof ( s_sz ) - 1, psz, cch, NULL );
}

/*//////////////////////////////////////////////////////////////////////
QVR}hsB
in	hn	m[hnhB
	psz	Tȏ̃̕AhXB
out	psz	t@[EFAo[W "d.dd"B
ret	G[R[hB
*/

int ZdVerGet( HZXN hn, LPSTR psz, DWORD cch )
{
DSCA( s_sz,	"QV\r" );

	return zn_zb_rs( hn, s_sz, sizeof ( s_sz ) - 1, psz, cch, NULL );
}

/*//////////////////////////////////////////////////////////////////////
QRR}hsB
in	hn	m[hnhB
	pB	jbgZNgXCb`ݒli[obt@
		AhXB
out	*pB	jbgZNgXCb`ݒlB
ret	G[R[hB
*/

int ZdSwtGet( HZXN hn, LPBYTE pB )
{
DSCA( s_sz,	"QR\r" );

	return zn_zb_rb( hn, s_sz, sizeof ( s_sz ) - 1, pB );
}

/*//////////////////////////////////////////////////////////////////////
QTR}hsB
in	hn	m[hnhB
	pB	foCX^Cvli[obt@̃AhXB
out	*pB	foCX^CvlB
ret	G[R[hB
*/

int ZdTypeGet( HZXN hn, LPBYTE pB )
{
DSCA( s_sz,	"QT\r" );

	return zn_zb_rb( hn, s_sz, sizeof ( s_sz ) - 1, pB );
}

/*//////////////////////////////////////////////////////////////////////
URR}hsB
in	hn	m[hnhB
ret	G[R[hB
*/

int ZdNop( HZXN hn )
{
DSCA( s_sz,	"UR\r" );

	return zn_zb_rn( hn, s_sz, sizeof ( s_sz ) - 1 );
}

/*//////////////////////////////////////////////////////////////////////
IPR}hsB
in	hn	m[hnhB
	iP	|[gԍB
	pB	foCX^Cvli[obt@̃AhXB
out	*pB	foCX^CvlB
ret	G[R[hB
*/

int ZdPortIn( HZXN hn, BYTE iP, LPBYTE pB )
{
DSCA( s_szF,	"IP %u\r" );
			/* command. */
	char	sC[ 16 ];
	int	cch;	/* # of characters. */

	cch = sprintf_s( sC, sizeof ( sC ), s_szF, iP );

	return zn_zb_rb( hn, sC, cch, pB );
}

/*//////////////////////////////////////////////////////////////////////
FSR}hsB
in	hn	m[hnhB
	iFreq	B
		0	tB^Ȃ
		1	 1260uS
		2	 2520uS
		3	 5040uS
		4	10080uS
		5	20160uS
	cStep	iB
ret	G[R[hB
*/

int ZdFiltSet( HZXN hn, BYTE iFreq, BYTE cStep )
{
DSCA( s_szF,	"FS %u %u\r" );
			/* command. */
	char	sC[ 32 ];
	int	cch;	/* # of characters. */

	cch = sprintf_s( sC, sizeof ( sC ), s_szF, iFreq, cStep );

	return zn_zb_rn( hn, sC, cch );
}

/*//////////////////////////////////////////////////////////////////////
TCR}hsB
in	hn	m[hnhB
	iP	|[gԍB
	iMode	[hB
		0	ĎȂ
		1	ω
		2	Sv
		3	v
	bm	Ώۃrbg}XNB
	bComp	rlB
ret	G[R[hB
*/

int ZdMonSet( HZXN hn, BYTE iP, BYTE iMode, BYTE bm, BYTE bComp )
{
DSCA( s_szF,	"TC %u %u %02X %02X\r" );
			/* command. */
	char	sC[ 32 ];
	int	cch;	/* # of characters. */

	cch = sprintf_s(
			sC,
			sizeof ( sC ),
			s_szF,
			iP,
			iMode,
			bm,
			bComp
			);

	return zn_zb_rn( hn, sC, cch );
}

/*//////////////////////////////////////////////////////////////////////
TSR}hsB
in	hn	m[hnhB
	iP	|[gԍB
	pStat	ĎԂ󂯎obt@̃AhXB
	pVal	vf[^󂯎obt@̃AhXB
out	*pStat	ĎԁB
		0	TCR}hŎw肵gK𖞂ĂȂB
		1	ߋɃgK𖞂ƂAA
			TSR}hœǂݎꂽƂȂB
	*pVal	vf[^B
		*pStat0̏ꍇ0B
ret	G[R[hB
*/

		/*
		// frame type,
		// source address,
		// 16-bit source address,
		// option,
		// RETURN PACKET.
		//	ee ss vv<CR>
		//		ee	16iQ̃G[R[h
		//		ss	16iQ̃Xe[^XR[h
		//		vv	16iQ̒l
		*/

#undef	CB_MIN
#define	CB_MIN	( 1 + 8 + 2 + 1 + 9 )

static	BOOL zd_ts_val( HZXN hn, LPXBAF prx )
{
	assert( NULL != hn );
	assert( NULL != prx );
	assert( XB_FT_RX_ZB == prx->hd.ft );

	( void )hn;

{
	DWORD	cbF;	/* bytes of rx frame data. */

	/*
	// ߂oCg
	*/

	cbF = PEEK_W( &prx->rxzb.CB );
	if ( CB_MIN > cbF )
	{
#ifdef	_DEBUG	/*[*/
		s_v.ce.cZdTSCb++;
#endif	/*]*/

		return FALSE;
	}

	return TRUE;
}
}

int ZdMonStatGet( HZXN hn, BYTE iP, LPBYTE pStat, LPBYTE pVal )
{
DSCA( s_szF,	"TS %u\r" );
			/* command. */
	char	sCR[ 64 ];
	TXBAF	rx;	/* response. */
	LPSTR	ps;	/* */
	int	cch;	/* # of characters. */
	int	ri;	/* result. */

	/*
	// setup command string.
	*/

	cch = sprintf_s( sCR, sizeof ( sCR ), s_szF, iP );

	/*
	// peripheral command.
	*/

	ri = zn_ex_zb( hn, &rx, sCR, cch, zd_ts_val );
	if ( ZXR_OK != ri )
	{
		return ri;
	}

{
	BYTE	bVal;	/* temporary. */

	/*
	// prepare output.
	*/

	bVal = ( BYTE )strtoul( 3 + rx.rxzb.ds, &ps, 16 );
	if ( NULL != pStat )
	{
		*pStat = bVal;
	}

	bVal = ( BYTE )strtoul( ++ps, &ps, 16 );
	if ( NULL != pVal )
	{
		*pVal = bVal;
	}
}

	return ZXR_OK;
}

/*//////////////////////////////////////////////////////////////////////
OPR}hsB
in	hn	m[hnhB
	iP	|[gԍB
	bVal	o̓f[^B
ret	G[R[hB
*/

int ZdPortOut( HZXN hn, BYTE iP, BYTE bVal )
{
DSCA( s_szF,	"OP %u %02X\r" );
			/* command. */
	char	sC[ 32 ];
	int	cch;	/* # of characters. */

	cch = sprintf_s( sC, sizeof ( sC ), s_szF, iP, bVal );

	return zn_zb_rn( hn, sC, cch );
}

/*//////////////////////////////////////////////////////////////////////
WTR}hsB
in	hn	m[hnhB
	iTmo	WDT^CAEgB
ret	G[R[hB
*/

int ZdWdtSet( HZXN hn, BYTE iTmo )
{
DSCA( s_szF,	"WT %u\r" );
			/* command. */
	char	sC[ 16 ];
	int	cch;	/* # of characters. */

	cch = sprintf_s( sC, sizeof ( sC ), s_szF, iTmo );

	return zn_zb_rn( hn, sC, cch );
}

/*//////////////////////////////////////////////////////////////////////
WRR}hsB
in	hn	m[hnhB
ret	G[R[hB
*/

int ZdWdtRst( HZXN hn )
{
DSCA( s_sz,	"WR\r" );

	return zn_zb_rn( hn, s_sz, sizeof ( s_sz ) - 1 );
}

/*//////////////////////////////////////////////////////////////////////
WOR}hsB
in	hn	m[hnhB
	iP	|[gԍB
	bVal	o̓f[^B
ret	G[R[hB
*/

int ZdWdtOutSet( HZXN hn, BYTE iP, BYTE bVal )
{
DSCA( s_szF,	"WO %u %02X\r" );
			/* command. */
	char	sC[ 32 ];
	int	cch;	/* # of characters. */

	cch = sprintf_s( sC, sizeof ( sC ), s_szF, iP, bVal );

	return zn_zb_rn( hn, sC, 8 );
}

/*//////////////////////////////////////////////////////////////////////
WSR}hsB
in	hn	m[hnhB
	pStat	WDTXe[^Xi[obt@̃AhXB
out	*pStat	WDTXe[^XB
ret	G[R[hB
*/

int ZdWdtStatGet( HZXN hn, LPBYTE pStat )
{
DSCA( s_sz,	"WS\r" );

	return zn_zb_rb( hn, s_sz, sizeof ( s_sz ) - 1, pStat );
}

/*//////////////////////////////////////////////////////////////////////
WCR}hsB
in	hn	m[hnhB
ret	G[R[hB
*/

int ZdWdtClr( HZXN hn )
{
DSCA( s_sz,	"WC\r" );

	return zn_zb_rn( hn, s_sz, sizeof ( s_sz ) - 1 );
}

/*//////////////////////////////////////////////////////////////////////
WZR}hsB
in	hn	m[hnhB
ret	G[R[hB
*/

int ZdWdtZero( HZXN hn )
{
DSCA( s_sz,	"WZ\r" );

	return zn_zb_rn( hn, s_sz, sizeof ( s_sz ) - 1 );
}

/*//////////////////////////////////////////////////////////////////////
WrbglԂuATR}hsB
in	hn	m[hnhB
	pszC	R}hB
	cchC	R}hB
	pV	Wrbgli[obt@̃AhXB
out	*pV	WrbglB
ret	G[R[hB
*/

int ZdAtRB( HZXN hn, LPCSTR pszC, DWORD cchC, LPBYTE pdb )
{
	return zn_rat_rb( hn, pszC, cchC, pdb );
}

/*//////////////////////////////////////////////////////////////////////
ATDBR}hsB
in	hn	m[hnhB
	pdb	dExi[obt@̃AhXB
out	*pdb	dExB
ret	G[R[hB
*/

int ZdAtdb( HZXN hn, LPBYTE pdb )
{
DSCA( s_sz,	"DB" );

	return zn_rat_rb( hn, s_sz, sizeof ( s_sz ) - 1, pdb );
}

/*//////////////////////////////////////////////////////////////////////
MRR}hsB
in	hn	m[hnhB
	dAddr	vZbTAhXB
	pVal	ǂݎli[obt@̃AhXB
ret	G[R[hB
*/

int ZdMcuGet( HZXN hn, DWORD dAddr, LPBYTE pVal )
{
DSCA( s_szF,	"MR %08lX\r" );
			/* command. */
	char	sC[ 32 ];
	int	cch;	/* # of characters. */

	cch = sprintf_s( sC, sizeof ( sC ), s_szF, dAddr );

	return zn_zb_rb( hn, sC, cch, pVal );
}

/*//////////////////////////////////////////////////////////////////////
MWR}hsB
in	hn	m[hnhB
	dAddr	vZbTAhXB
	bVal	ޒlB
ret	G[R[hB
*/

int ZdMcuPut( HZXN hn, DWORD dAddr, BYTE bVal )
{
DSCA( s_szF,	"MW %08lX %02X\r" );
			/* command. */
	char	sC[ 32 ];
	int	cch;	/* # of characters. */

	cch = sprintf_s( sC, sizeof ( sC ), s_szF, dAddr, bVal );

	return zn_zb_rn( hn, sC, cch );
}
