/*	cpizxio.h

CPI-ZD䃉Cu\z

Copyright (C) CPI Technologies, Inc.
*/

#ifndef	CPIZXIO_H	/*[*/
#define	CPIZXIO_H	1

#include "xbee.h"

#ifdef	__cplusplus
extern	"C"
{
#endif

/*//////////////////////////////////////////////////////////////////////
build flag.
*/

/*
// Mt[Lv`
*/
#if	1	/*[*/
#define	BF_CAPT_FRAME	1
#endif	/*]*/

#ifdef	BF_CAPT_FRAME	/*[*/

/*//////////////////////////////////////////////////////////////////////
*/

void zx_capt_beg( void );
void zx_capt_end( void );

#endif	/*]*/

/*//////////////////////////////////////////////////////////////////////
*/

#define	ZXE_AT		( -11 )	/* invalid command. */
#define	ZXE_XB		( -10 )	/* error in XBee. */
#define	ZXE_SUM		( -9 )	/* checksum error. */
#define	ZXE_SYS		( -8 )	/* system error. */
#define	ZXE_LOCK	( -7 )	/* i/o blocking timeout. */
#define	ZXE_ARG		( -6 )	/* invalid argument, etc. */
#define	ZXE_RX		( -5 )	/* rx timeout. */
#define	ZXE_TX		( -4 )	/* tx error. */
#define	ZXE_COMM	( -3 )	/* communication error. */
#define	ZXE_SEL		( -2 )	/* invalid device #. */
#define	ZXE_HANDLE	( -1 )	/* invalid handle. */
#define	ZXR_OK		0	/* succeeded. */
	/*
	// positive error code is returned by firmware.
	*/
#define	ZXR_ARG		5	/* sȂ */
#define	ZXR_PORT	6	/* ȃ|[g */
#define	ZXR_NO_DATA	7	/* gK */
#define	ZXR_FREQ	0x21	/* ȃtB^Ԋu */
#define	ZXR_MODE	0x31	/* ȊĎ[h */
#define	ZXR_TIMEOUT	0x41	/* WDT^CAEg */
#define	ZXR_COMMAND	0x80	/* ȃR}h */

#define	ZXC_MAX_DEVS	64	/* maximum # of devices. */

/*//////////////////////////////////////////////////////////////////////
*/

struct	SZXC;

typedef	struct	/* m[h */
{
        			/* R[fBl[^ */
        struct SZXC FAR*	hc;

	UINT	ix;		/* m[hԍ */

	DWORD	sh;		/* VAԍ */
	DWORD	sl;		/* VAԍ */
	WORD	my;		/* 16rbgElbg[NEAhX */

	DWORD	SH;		/* VAԍ */
	DWORD	SL;		/* VAԍ */
	WORD	PA;		/* ẽlbg[NEAhX */
	WORD	MY;		/* 16rbgElbg[NEAhX */
	WORD	PI;		/* vt@CID */
	WORD	FI;		/* HID */
				/* foCXE^Cv */
				/*	0: R[fBl[^ */
				/*	1: [^ */
	BYTE	dt;		/*	2: GhEfoCX */
	BYTE	st;		/* Xe[^X */
				/* lbg[NID */
	char	ni[ 1 + XB_CCH_MAX_NI ];

	TXBAF	txzb;		/* ZigBeeMvt[ */
	TXBAF	txrat;		/* uATR}hvt[ */

	BYTE	nRetry;		/* last ZigBee transmit retry. */
	BYTE	stDelivery;	/* last ZigBee delivery status. */
	BYTE	stDiscovery;	/* last ZigBee discovery status. */

	BYTE	stRAT;		/* last remote AT command status. */
}	TZXN;

typedef	TZXN FAR*	HZXN;

typedef	struct	SZXC	/* coordinator control. */
{
	HANDLE	hxComm;		/* ʐM|[grANZX */
	HANDLE	hComm;		/* ʐM|[g */
	OVERLAPPED
		oComm;		/* 񓯊I/O */
	COMMTIMEOUTS
		tmo;		/* ʐM^CAEg */
	DWORD	cmsTmo;		/* ʐM^CAEg */
	int	iComm;		/* ʐM|[gԍ */
	BOOL	fError;		/* G[tO */

				/* lbg[NID */
	char	ni[ 1 + XB_CCH_MAX_NI ];

				/* m[he[u */
	TZXN	aN[ ZXC_MAX_DEVS ];
	UINT	nN;		/* Lm[h */

	TXBAF	txat;		/* ATR}hvt[ */

	BYTE	stAT;		/* last AT command status. */
	BYTE	stModem;	/* fXe[^X */
}	TZXC;

typedef	TZXC FAR*	HZXC;

/*//////////////////////////////////////////////////////////////////////
XBee.
*/

int ZxClose( HZXC hz );
HZXC ZxOpen( UINT iComm, DWORD cmsTmo );
BOOL ZxReady( HZXC hz );
int ZxUnlock( HZXC hz );
int ZxLock( HZXC hz, DWORD cmsTmo );

int ZxAt( HZXC hz, LPCSTR pszC, DWORD cchC, LPVOID pb, DWORD cb, LPDWORD pcb );

int ZxAtB( HZXC hz, LPCSTR pszC, DWORD cchC, WORD vP );
int ZxAtW( HZXC hz, LPCSTR pszC, DWORD cchC, WORD vP );

BOOL ZxIsZc( HZXC hz );

/*//////////////////////////////////////////////////////////////////////
CPI-ZC.
*/

int ZcEnum( HZXC hz );

/*//////////////////////////////////////////////////////////////////////
PANɎQĂm[h擾B
in	hz	nhB
ret	m[hB
	̏ꍇ̓G[R[hB
ZcEnumĂяǒŖ{֐Ăяo܂B
*/

static	_inline int ZcNum( HZXC hz )
{
	if ( NULL == hz )
	{
		return ZXE_HANDLE;
	}

	return ( int )hz->nN;
}

/*//////////////////////////////////////////////////////////////////////
wm[h̏擾B
in	hz	R[fBl[^nhB
	iN	Ώۃm[hԍB
		hz->aÑCfbNXwB
ret	NULL	ُIB
	else	m[h̃AhXim[hnhjB
ZcEnumĂяǒŖ{֐Ăяo܂B
*/

static	_inline HZXN ZcDev( HZXC hz, UINT iN )
{
	if ( NULL == hz || hz->nN <= iN )
	{
		return NULL;
	}

	return iN + hz->aN;
}

/*//////////////////////////////////////////////////////////////////////
CPI-ZD.
*/

/*======================================================================
unit type.
*/

#define	ZD_TYPE_ZD132		001
#define	ZD_TYPE_ZD232		002
#define	ZD_TYPE_ZD332		003

#define	ZD_TYPE_UD132		011
#define	ZD_TYPE_UD232		012
#define	ZD_TYPE_UD332		013

/*----------------------------------------------------------------------
port.
*/

#define	ZD_PORT_A		0
#define	ZD_PORT_B		1
#define	ZD_PORT_C		2
#define	ZD_PORT_D		3
#define	ZD_NUM_PORTS		4

#define	ZD_NUM_OUT_PORTS	2
#define	ZD_MIN_IN_PORT		2

/*----------------------------------------------------------------------
filter frequency.
*/

#define	ZD_FILT_FREQ_STOP	0
#define	ZD_FILT_FREQ_1260	1	/* 1260uS */
#define	ZD_FILT_FREQ_2520	2
#define	ZD_FILT_FREQ_5040	3
#define	ZD_FILT_FREQ_10080	4
#define	ZD_FILT_FREQ_20160	5	/* 20160uS */
#define	ZD_NUM_FILT_FREQS	6

/*----------------------------------------------------------------------
WDT timeout.
*/

#define	ZD_WDT_TMO_STOP		0
#define	ZD_WDT_TMO_126		1	/* 126mS */
#define	ZD_WDT_TMO_252		2
#define	ZD_WDT_TMO_504		3
#define	ZD_WDT_TMO_1008		4
#define	ZD_WDT_TMO_2016		5	/* 2016mS */
#define	ZD_WDT_TMO_6		6	/* 6S */
#define	ZD_WDT_TMO_255		255	/* 255S */

/*----------------------------------------------------------------------
WDT status.
*/

#define	ZD_WDT_STAT_STOP	0	/* ~ */
#define	ZD_WDT_STAT_RUN		0	/* JEg */
#define	ZD_WDT_STAT_TMO		1	/* ^CAEg */

/*----------------------------------------------------------------------
port monitor mode.
*/

#define	ZD_MON_NONE		0	/* ĎȂ */
#define	ZD_MON_ALT		1	/* ω */
#define	ZD_MON_AND		2	/* Sv */
#define	ZD_MON_OR		3	/* v */
#define	ZD_NUM_MON_MODES	4

/*======================================================================
function.
*/

BOOL ZnIsZd132( HZXN hn );
BOOL ZnIsZd232( HZXN hn );
BOOL ZnIsZd332( HZXN hn );

LPCTSTR ZdErrStr( int iErr );
int ZdErrGet( HZXN hn );
int ZdDevGet( HZXN hn, LPSTR psz, DWORD cch );
int ZdVerGet( HZXN hn, LPSTR psz, DWORD cch );
int ZdSwtGet( HZXN hn, LPBYTE pB );
int ZdTypeGet( HZXN hn, LPBYTE pB );
int ZdNop( HZXN hn );
int ZdPortIn( HZXN hn, BYTE iP, LPBYTE pB );
int ZdFiltSet( HZXN hn, BYTE iFreq, BYTE cStep );
int ZdMonSet( HZXN hn, BYTE iP, BYTE iMode, BYTE bm, BYTE bComp );
int ZdMonStatGet( HZXN hn, BYTE iP, LPBYTE pStat, LPBYTE pVal );
int ZdPortOut( HZXN hn, BYTE iP, BYTE bVal );
int ZdWdtSet( HZXN hn, BYTE iTmo );
int ZdWdtRst( HZXN hn );
int ZdWdtOutSet( HZXN hn, BYTE iP, BYTE bVal );
int ZdWdtStatGet( HZXN hn, LPBYTE pStat );
int ZdWdtClr( HZXN hn );
int ZdWdtZero( HZXN hn );

int ZdAtRB( HZXN hn, LPCSTR pszC, DWORD cchC, LPBYTE pV );
int ZdAtdb( HZXN hn, LPBYTE pdb );

int ZdMcuGet( HZXN hn, DWORD dAddr, LPBYTE pVal );
int ZdMcuPut( HZXN hn, DWORD dAddr, BYTE bVal );

#ifdef	__cplusplus
}
#endif

#endif	/*]*/
