/*	edit16.c

	hexadecimal edit control.

	Copyright (C) CPI Technologies, Inc.
*/

/*//////////////////////////////////////////////////////////////////////
build flags.
*/

#define	BFL_LO		FALSE
#define	BFL_UP		TRUE

/*//////////////////////////////////////////////////////////////////////
*/

#pragma warning( disable: 4115 4201 4214 4514 )
#include <windows.h>
#pragma warning( 1: 4115 4201 4214 )
#include <tchar.h>

#include "edit16.h"

/*//////////////////////////////////////////////////////////////////////
*/

#define	MAX_COL		32

#ifdef	_M_X64	/*[*/

#define	WL_USERDATA	GWLP_USERDATA
#define	WL_WNDPROC	GWLP_WNDPROC

#define	TWLONG		LONG_PTR

#define	WLG		GetWindowLongPtr
#define	WLS		SetWindowLongPtr

#else	/*][*/

#define	WL_USERDATA	GWL_USERDATA
#define	WL_WNDPROC	GWL_WNDPROC

#define	TWLONG		long

#define	WLG		GetWindowLong
#define	WLS		SetWindowLong

#endif	/*]*/

#define	LENGTH_OF( ar )		( sizeof ( ar ) / sizeof ( *ar ) )

/*//////////////////////////////////////////////////////////////////////
*/

static	LRESULT CALLBACK cb_e16( HWND hw, UINT uM, WPARAM wP, LPARAM lP )
{
	if ( WM_CHAR == uM )
	{
		switch ( wP )
		{
		default:
			/*
			//
			*/

			return 0;		/* processed. */

		case VK_BACK:
		case VK_TAB:
		case VK_CLEAR:
		case VK_RETURN:
		case VK_NEXT:
		case VK_END:
		case VK_HOME:
		case VK_LEFT:
		case VK_UP:
		case VK_RIGHT:
		case VK_DOWN:
		case VK_DELETE:

		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			break;

		case 'A':
		case 'B':
		case 'C':
		case 'D':
		case 'E':
		case 'F':
#if	BFL_LO	/*[*/
			wP = _totlower( ( TCHAR )wP );
#endif	/*]*/
			break;

		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
		case 'f':
#if	BFL_UP	/*[*/
			wP = _totupper( ( TCHAR )wP );
#endif	/*]*/
			break;
		}
	}

{
	WNDPROC	pfn0;	/* original. */

	/*
	// ʃRsyłȂxłȂƎv܂̂
	// Ă܂B
	*/

	pfn0 = ( WNDPROC )WLG( hw, WL_USERDATA );
	if ( NULL == pfn0 )
	{
		return ~ 0UL;
	}

	return CallWindowProc( pfn0, hw, uM, wP, lP );
}
}

/*//////////////////////////////////////////////////////////////////////
*/

BOOL e16( HWND he, UINT nCol )
{
	TWLONG	pfn;

	if ( nCol < 1 || MAX_COL < nCol )
	{
		nCol = MAX_COL;
	}
	( void )SendMessage( he, EM_LIMITTEXT, nCol, 0 );

	pfn = WLS( he, WL_WNDPROC, ( TWLONG )cb_e16 );
	if ( ! pfn )
	{
		return FALSE;
	}

	( void )WLS( he, WL_USERDATA, pfn );

	return TRUE;
}

/*//////////////////////////////////////////////////////////////////////
*/

DWORD e16_getd( HWND he )
{
	TCHAR	sz[ 1 + MAX_COL ];

	if ( 1 > GetWindowText( he, sz, LENGTH_OF( sz ) ) )
	{
		return ~ 1UL;
	}

	return _tcstoul( sz, NULL, 0x10 );
}
