/*	elog.c

	output log to edit control.

	Copyright (C) CPI Technologies, Inc.
*/

#pragma	warning( disable: 4115 4201 4214 4514 )
#include <windows.h>
#pragma	warning( 1: 4115 4201 4214 )
#include <tchar.h>

#include <assert.h>

#include "tchars.h"

#include "elog.h"

/*//////////////////////////////////////////////////////////////////////
*/

#define	EMSS_START_NONE		( ( WPARAM )-2 )
#define	EMSS_END_NONE		( -1L )
#define	EMSS_START_ALL		0U
#define	EMSS_END_ALL		( -1L )

#define	LENGTH_OF( ar )		( sizeof ( ar ) / sizeof ( *ar ) )

#define	DSCT( id, st )		static TCHAR const id[] = _T( st )
#define	DSCA( id, st )		static char const id[] = st
#define	DSCW( id, st )		static WCHAR const id[] = L##st

/*//////////////////////////////////////////////////////////////////////
fix_init Ŋmۂ\[X܂B
*/

static	BOOL fix_done( HELOG hl )
{
	if ( NULL == hl || NULL == hl->he )
	{
		return FALSE;
	}

	if ( NULL != hl->h0f )		/* need to restore font ? */
	{
		HDC	hdc;		/* device context */

		/* get display context */

		hdc = GetDC( hl->he );
		if ( NULL != hdc )
		{
			/* restore font */

			( void )SelectObject( hdc, hl->h0f );

			/* here, display context is not necessary */

			( void )ReleaseDC( hl->he, hdc );
		}
	}

	/* delete created font */

	( void )DeleteObject( hl->hf );
	hl->hf = NULL;

	return TRUE;
}

/*//////////////////////////////////////////////////////////////////////
Œsb`tHgɂ܂B
*/

static	BOOL fix_init( HELOG hl, long nF )
{
DSCT( s_szFace,		"lr SVbN" );
	LOGFONT	lf;	/* log font */
	HDC	hdc;	/* device context */

	assert( NULL != hl );
	assert( NULL != hl->he );

	/* fixed pitch font */

	lf.lfHeight		= nF;
	lf.lfWidth		= 0;	/* default */
	lf.lfEscapement		= 0;
	lf.lfOrientation	= 0;
	lf.lfWeight		= FW_NORMAL;
	lf.lfItalic		= FALSE;
	lf.lfUnderline		= FALSE;
	lf.lfStrikeOut		= FALSE;
	lf.lfCharSet		= DEFAULT_CHARSET;
	lf.lfOutPrecision	= OUT_CHARACTER_PRECIS;
	lf.lfClipPrecision	= CLIP_CHARACTER_PRECIS;
	lf.lfQuality		= DEFAULT_QUALITY;
	lf.lfPitchAndFamily	= FIXED_PITCH | FF_DONTCARE;
	( void )_tcscpy_s(
			lf.lfFaceName,
			LENGTH_OF( lf.lfFaceName ),
			s_szFace
			);

	hl->hf = CreateFontIndirect( &lf );
	if ( NULL == hl->hf )
	{
		return FALSE;
	}

	/* get display context */

	hdc = GetDC( hl->he );
	if ( NULL == hdc )
	{
		/* delete created font */

		( void )fix_done( hl );

		return FALSE;
	}

	/* install new font in current display context */

	hl->h0f = SelectObject( hdc, hl->hf );
	if ( NULL != hl->h0f )
	{
		/* please draw with new font */

		( void )PostMessage(
				hl->he,
				WM_SETFONT,
				( WPARAM )hl->hf,
				0
				);
	}

	/* here, display context is not necessary */

	( void )ReleaseDC( hl->he, hdc );

	return TRUE;
}

/*//////////////////////////////////////////////////////////////////////
el_cre ō쐬ꂽEBhȄꍇ DestroyWindow ܂B
*/

BOOL WINAPI el_clo( HELOG hl )
{
	if ( ! fix_done( hl ) )
	{
		return FALSE;
	}

	/*==============================================================
	// window
	*/

	if ( hl->fCre )
	{
		if ( NULL != hl->he )
		{
			( void )DestroyWindow( hl->he );
		}
	}

	/*==============================================================
	// object
	*/

	( void )LocalFree( ( HLOCAL )hl );

	return TRUE;
}

/*//////////////////////////////////////////////////////////////////////
O\pEDITRg[쐬܂B
in	hwP	eEBhE
	x	NCAgGA
	y	NCAgGA
	nW	Rg[̕
	nH	Rg[̍
	nF	Œsb`tHg̑傫H
ret	NULL:	G[
	else:	IuWFNg̃nh
*/

HELOG WINAPI el_cre( HWND hwP, int x, int y, int nW, int nH, long nF )
{
	HELOG	hl;

	/*==============================================================
	// object
	*/

	hl = LocalAlloc( LPTR, sizeof ( *hl ) );
	if ( NULL == hl )
	{
		return NULL;
	}

	/*==============================================================
	// window
	*/
{
DSCT( s_szWCEdit,	"EDIT" );

	hl->he = CreateWindowEx(
			WS_EX_CLIENTEDGE,
			s_szWCEdit,
			NULL,
			WS_CHILD | WS_VISIBLE
					| ES_WANTRETURN | ES_MULTILINE
					| ES_AUTOVSCROLL | WS_VSCROLL
					| ES_AUTOHSCROLL | WS_HSCROLL
					| ES_READONLY
					,
			x,
			y,
			nW,
			nH,
			hwP,
			NULL,
			GetModuleHandle( NULL ),
			NULL
			);
	if ( NULL == hl->he )
	{
		goto L_ERROR;
	}

	hl->fCre = TRUE;
}

	/*==============================================================
	//
	*/

	( void )SendMessage( hl->he, EM_LIMITTEXT, 0, 0 );

	/*==============================================================
	// font
	*/

	if ( ! fix_init( hl, nF ) )
	{
		goto L_ERROR;
	}

	/*==============================================================
	//
	*/

	( void )ShowWindow( hl->he, SW_NORMAL );

	( void )UpdateWindow( hl->he );

	return hl;

L_ERROR:
	( void )el_clo( hl );

	return NULL;
}

/*//////////////////////////////////////////////////////////////////////
O\pEDITRg[蓖Ă܂B
in	heL	O\Ώۂ̍쐬ς EDIT Rg[w肵܂B
	nF	Œsb`tHg̑傫H
ret	NULL:	G[
	else:	IuWFNg̃nh
*/

HELOG WINAPI el_cat( HWND heL, long nF )
{
	HELOG	hl;

	if ( NULL == heL )
	{
		return FALSE;
	}

	/*==============================================================
	// object
	*/

	hl = LocalAlloc( LPTR, sizeof ( *hl ) );
	if ( NULL == hl )
	{
		return NULL;
	}

	/*==============================================================
	// window
	*/

	hl->he = heL;
	hl->fCre = FALSE;

	/*==============================================================
	//
	*/

	( void )SendMessage( heL, EM_LIMITTEXT, 0, 0 );

	/*==============================================================
	// font
	*/

	if ( ! fix_init( hl, nF ) )
	{
		goto L_ERROR;
	}

	return hl;

L_ERROR:
	el_clo( hl );

	return NULL;
}

/*//////////////////////////////////////////////////////////////////////
ONA܂B
*/

void WINAPI el_clr( HELOG hl )
{
DSCT( s_szNull,		"" );

	assert( NULL != hl );

	( void )SetWindowText( hl->he, s_szNull );
}

/*//////////////////////////////////////////////////////////////////////
Oɕǉ܂B
*/

static	_inline	void ADDSA( HWND he, LPCSTR psz )
{
	assert( NULL != he );

	if ( ! IsWindow( he ) )
	{
		return;
	}

	( void )SendMessageA(
			he,
			EM_SETSEL,
			EMSS_START_NONE,
			EMSS_END_NONE
			);

	( void )SendMessageA(
			he,
			EM_REPLACESEL,
			0,
			( LPARAM )psz
			);
}

/*//////////////////////////////////////////////////////////////////////
Oɕǉ܂B
CRŕςȏ܂B
߂ႭłB
*/

#define	EOS		0
#define	LF		10
#define	CR		13
#define	CH_UNPRINT	'.'

void WINAPI el_outsA( HELOG hl, LPCSTR psz )
{
	char	sz[ 1 + 4095 ];
	LPSTR	pszD;

	assert( NULL != hl );

	for ( pszD = sz; *psz; psz++ )
	{
		if ( CR == *psz )
		{
			if ( LF == psz[ 1 ] )
			{
				psz++;
			}
			*pszD++ = CH_UNPRINT;
			*pszD++ = CR;
			*pszD++ = LF;
		}
		else if ( LF == *psz )
		{
			*pszD++ = CH_UNPRINT;
			*pszD++ = CR;
			*pszD++ = LF;
		}
		else
		{
			*pszD++ = *psz;
		}
	}
	*pszD = EOS;

	ADDSA( hl->he, sz );
}

/*//////////////////////////////////////////////////////////////////////
Oɕǉ܂B
*/

void WINAPI el_putsA( HELOG hl, LPCSTR psz )
{
	assert( NULL != hl );

	ADDSA( hl->he, psz );
}

/*//////////////////////////////////////////////////////////////////////
tH[}bg쐬AOɒǉ܂B
*/

void WINAPI el_vputfA( HELOG hl, LPCSTR pszForm, va_list vl )
{
	char	sz[ 1 + 2047 ];

	assert( NULL != hl );

	( void )wvsprintfA( sz, pszForm, vl );

	ADDSA( hl->he, sz );
}

/*//////////////////////////////////////////////////////////////////////
tH[}bg쐬AOɒǉ܂B
*/

void _cdecl el_putfA( HELOG hl, LPCSTR pszForm, ... )
{
	va_list	vl;

	assert( NULL != hl );

	va_start( vl, pszForm );
	( void )el_vputfA( hl, pszForm, vl );
	va_end( vl );
}

/*//////////////////////////////////////////////////////////////////////
Oɕǉ܂B
*/

static	_inline	void ADDSW( HWND he, LPCWSTR psz )
{
	assert( NULL != he );

	if ( ! IsWindow( he ) )
	{
		return;
	}

	( void )SendMessageW(
			he,
			EM_SETSEL,
			EMSS_START_NONE,
			EMSS_END_NONE
			);

	( void )SendMessageW(
			he,
			EM_REPLACESEL,
			0,
			( LPARAM )psz
			);
}

/*//////////////////////////////////////////////////////////////////////
Oɕǉ܂B
CRŕςȏ܂B
߂ႭłB
*/

void WINAPI el_outsW( HELOG hl, LPCWSTR psz )
{
	WCHAR	sz[ 1 + 4095 ];
	LPWSTR	pszD;

	assert( NULL != hl );

	for ( pszD = sz; *psz; psz++ )
	{
		if ( CR == *psz )
		{
			if ( LF == psz[ 1 ] )
			{
				psz++;
			}
			*pszD++ = CH_UNPRINT;
			*pszD++ = CR;
			*pszD++ = LF;
		}
		else if ( LF == *psz )
		{
			*pszD++ = CH_UNPRINT;
			*pszD++ = CR;
			*pszD++ = LF;
		}
		else
		{
			*pszD++ = *psz;
		}
	}
	*pszD = EOS;

	ADDSW( hl->he, sz );
}

/*//////////////////////////////////////////////////////////////////////
Oɕǉ܂B
*/

void WINAPI el_putsW( HELOG hl, LPCWSTR psz )
{
	assert( NULL != hl );

	ADDSW( hl->he, psz );
}

/*//////////////////////////////////////////////////////////////////////
tH[}bg쐬AOɒǉ܂B
*/

void WINAPI el_vputfW( HELOG hl, LPCWSTR pszForm, va_list vl )
{
	WCHAR	sz[ 1 + 2047 ];

	assert( NULL != hl );

	( void )wvsprintfW( sz, pszForm, vl );

	ADDSW( hl->he, sz );
}

/*//////////////////////////////////////////////////////////////////////
tH[}bg쐬AOɒǉ܂B
*/

void _cdecl el_putfW( HELOG hl, LPCWSTR pszForm, ... )
{
	va_list	vl;

	assert( NULL != hl );

	va_start( vl, pszForm );
	( void )el_vputfW( hl, pszForm, vl );
	va_end( vl );
}
