/*	main.c

	main.

	tab	= 8
*/

#pragma	warning( disable: 4115 4201 4214 4514 )
#include <windows.h>
#pragma	warning( 1: 4115 4201 4214 )
#include <tchar.h>

#include <assert.h>

#include "resource.h"

#include "tchars.h"
#include "zx.h"

/*//////////////////////////////////////////////////////////////////////
*/

#define	LENGTH_OF( ar )	( sizeof ( ar ) / sizeof ( *ar ) )

#define	DSCT( id, st )	static TCHAR const id[] = _T( st )

/*//////////////////////////////////////////////////////////////////////
*/

static	LRESULT CALLBACK cb_wnd( HWND hw, UINT uM, WPARAM wP, LPARAM lP );

/*//////////////////////////////////////////////////////////////////////
*/

DSCT( s_szWC,	"CHKZDX32" );

/*//////////////////////////////////////////////////////////////////////
*/

static	struct
{
	HWND	hw;	/*  window: main. */
	HWND	hd;	/*  dialog: main. */
			/*  dialog: units. */
	HWND	ahd[ ZXC_MAX_DEVS ];
}	s_v;

/*//////////////////////////////////////////////////////////////////////
*/

static	_inline BOOL is_dlg_msg( LPMSG pm )
{
	HWND FAR*	phd;

	if ( IsWindow( s_v.hd ) && IsDialogMessage( s_v.hd, pm ) )
	{
		return TRUE;
	}

	for ( phd = s_v.ahd; phd < s_v.ahd + LENGTH_OF( s_v.ahd ); phd++ )
	{
		if ( IsWindow( *phd ) && IsDialogMessage( *phd, pm ) )
		{
			return TRUE;
		}
	}

	return FALSE;
}

/*//////////////////////////////////////////////////////////////////////
*/

int WINAPI _tWinMain( HINSTANCE hi, HINSTANCE h0i, LPTSTR pszLine, int iShow )
{
DSCT( s_szFERegisterClass,	"RegisterClass failed.\r\nError: %ld" );
DSCT( s_szFECreateWindow,	"CreateWindow failed.\r\nError: %ld" );
	MSG	msg;	/* message. */

	( void )pszLine;
	( void )iShow;

	assert( NULL != hi );

	if ( NULL == h0i )
	{
		WNDCLASS	wc;
		HICON	hic;

		hic = LoadIcon( hi, MAKEINTRESOURCE( IDI_MAIN ) );

		wc.style		= CS_HREDRAW | CS_VREDRAW;
		wc.lpfnWndProc		= cb_wnd;
		wc.cbClsExtra		= 0;
		wc.cbWndExtra		= 0;
		wc.hInstance		= hi;
		wc.hIcon		= hic;
		wc.hCursor		= LoadCursor( NULL, IDC_ARROW );
		wc.hbrBackground	= NULL;
		wc.lpszMenuName		= NULL;
		wc.lpszClassName	= s_szWC;

		if ( ! RegisterClass( &wc ) )
		{
			( void )mbox(
					NULL,
					MB_OK | MB_ICONEXCLAMATION,
					s_szWC,
					s_szFERegisterClass,
					GetLastError()
					);

			return -1;
		}
	}

	s_v.hw = CreateWindow(
			s_szWC,
			_T( "" ),
			WS_OVERLAPPEDWINDOW,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			0,
			0,
			NULL,
			NULL,
			hi,
			NULL
			);
	if ( NULL == s_v.hw )
	{
		( void )mbox(
				NULL,
				MB_OK | MB_ICONEXCLAMATION,
				s_szWC,
				s_szFECreateWindow,
				GetLastError()
				);

		return -2;
	}

	( void )PostMessage( s_v.hw, WM_X_1ST, 0, 0 );

	while ( GetMessage( &msg, NULL, 0, 0 ) )
	{
		if ( is_dlg_msg( &msg ) )
		{
			continue;
		}

		( void )TranslateMessage( &msg );

		( void )DispatchMessage( &msg );
	}

	return ( int )msg.wParam;
}

/*//////////////////////////////////////////////////////////////////////
*/

static	LRESULT on_close( HWND hw );
static	LRESULT on_x_1st( HWND hw  );
static	LRESULT on_x_zap( void );
static	LRESULT on_x_close( UINT iU );
static	LRESULT on_x_open( HZXN hv );

/*//////////////////////////////////////////////////////////////////////
*/

static	LRESULT CALLBACK cb_wnd( HWND hw, UINT uM, WPARAM wP, LPARAM lP )
{
	switch ( uM )
	{
	default:
		return DefWindowProc( hw, uM, wP, lP );

	case WM_DESTROY:
		PostQuitMessage( 0 );
		break;

	case WM_CLOSE:
		return on_close( hw );

	case WM_X_1ST:
		return on_x_1st( hw );

	case WM_X_ZAP:
		return on_x_zap();

	case WM_X_CLOSE:
		return on_x_close( ( UINT )wP );

	case WM_X_OPEN:
		return on_x_open( ( HZXN )lP );
	}

	return 0;
}

/*//////////////////////////////////////////////////////////////////////
*/

static	LRESULT on_close( HWND hw )
{
	( void )DestroyWindow( hw );
	s_v.hw = NULL;

	return 0;
}

/*//////////////////////////////////////////////////////////////////////
*/

static	LRESULT on_x_1st( HWND hw )
{
	s_v.hd = zc001( hw );

	return 0;
}

/*//////////////////////////////////////////////////////////////////////
*/

static	LRESULT on_x_close( UINT iU )
{
	assert( ZXC_MAX_DEVS > iU );
	assert( NULL != s_v.ahd[ iU ] );

	s_v.ahd[ iU ] = NULL;

	return 0;
}

/*//////////////////////////////////////////////////////////////////////
*/

static	LRESULT on_x_open( HZXN hv )
{
	HWND	hw;	/* temp. */

	assert( NULL != hv );
	assert( ZXC_MAX_DEVS > hv->ix );

	hw = s_v.ahd[ hv->ix ];
	if ( NULL == hw )
	{
		s_v.ahd[ hv->ix ] = zdx32( s_v.hw, hv );

		return 0;
	}

	( void )ShowWindow( hw, SW_NORMAL );

	( int )SetForegroundWindow( hw );

	return 0;
}

/*//////////////////////////////////////////////////////////////////////
*/

static	LRESULT on_x_zap( void )
{
	UINT	ii;	/* iterator. */

	for ( ii = 0; ii < ZXC_MAX_DEVS; ii++ )
	{
		if ( NULL == s_v.ahd[ ii ] )
		{
			continue;
		}

		( void )PostMessage(
				s_v.ahd[ ii ],
				WM_COMMAND,
				MAKELONG( IDOK, BN_CLICKED ),
				0
				);
	}

	return 0;
}

/*//////////////////////////////////////////////////////////////////////
*/

int vmbox( HWND hw0, UINT bmStyle, LPCTSTR pszCap, LPCTSTR pszForm, va_list vl )
{
	TCHAR	szMes[ 1 + 4095 ];

	( void )_vstprintf_s( szMes, LENGTH_OF( szMes ), pszForm, vl );

	return MessageBox( hw0, szMes, pszCap, bmStyle );
}

/*//////////////////////////////////////////////////////////////////////
*/

int mbox( HWND hw0, UINT bmStyle, LPCTSTR pszCap, LPCTSTR pszForm, ... )
{
	va_list	vl;	/* arguments. */
	int	ri;	/* result. */

	va_start( vl, pszForm );
	ri = vmbox( hw0, bmStyle, pszCap, pszForm, vl );
	va_end( vl );

	return ri;
}
