/*	tchars.h

	蔲߂łˁB

	Copyright (C) CPI Technologies, Inc.
*/

#ifndef	TCHARS_H	/*[*/
#define	TCHARS_H	1

#if	1200 >= _MSC_VER	/*[*/

#include <tchar.h>

#include <stdio.h>
#include <errno.h>
#include <locale.h>

/*//////////////////////////////////////////////////////////////////////
*/

#ifdef	__cplusplus
extern	"C"
{
#endif

/*//////////////////////////////////////////////////////////////////////
*/

#ifndef	FAR	/*[*/
#define	FAR
#endif	/*]*/

/*//////////////////////////////////////////////////////////////////////
*/

typedef	int	errno_t;
typedef	void FAR*	locale_t;

/*//////////////////////////////////////////////////////////////////////
*/

#ifdef	_MBCS	/*[*/
#define	_tcscat_s	strcat_s
#else	/*][*/
#define	_tcscat_s	wcscat_s
#endif	/*]*/

static	_inline
errno_t strcat_s( LPSTR pszD, size_t cchD, LPCSTR pszS )
{
	( void )cchD;

	if ( NULL == pszD )
	{
		return errno = EINVAL;
	}

	( void )strcat( pszD, pszS );

	return 0;
}

static	_inline
errno_t wcscat_s( LPWSTR pszD, size_t cchD, LPCWSTR pszS )
{
	( void )cchD;

	if ( NULL == pszD )
	{
		return errno = EINVAL;
	}

	( void )wcscat( pszD, pszS );

	return 0;
}

/*//////////////////////////////////////////////////////////////////////
*/

#ifdef	_MBCS	/*[*/
#define	_tcscpy_s	strcpy_s
#else	/*][*/
#define	_tcscpy_s	wcscpy_s
#endif	/*]*/

static	_inline
errno_t strcpy_s( LPSTR pszD, size_t cchD, LPCSTR pszS )
{
	( void )cchD;

	if ( NULL == pszD )
	{
		return errno = EINVAL;
	}

	( void )strcpy( pszD, pszS );

	return 0;
}

static	_inline
errno_t wcscpy_s( LPWSTR pszD, size_t cchD, LPCWSTR pszS )
{
	( void )cchD;

	if ( NULL == pszD )
	{
		return errno = EINVAL;
	}

	( void )wcscpy( pszD, pszS );

	return 0;
}

/*//////////////////////////////////////////////////////////////////////
*/

#ifdef	_MBCS	/*[*/
#define	_tcstok_s	strtok_s
#else	/*][*/
#define	_tcstok_s	wcstok_s
#endif	/*]*/

static	_inline
LPSTR strtok_s( LPSTR psz, LPCSTR pszDelim, LPSTR* ppszPos )
{
	( void )ppszPos;

	return strtok( psz, pszDelim );
}

static	_inline
LPWSTR wcstok_s( LPWSTR psz, LPCWSTR pszDelim, LPWSTR* ppszPos )
{
	( void )ppszPos;

	return wcstok( psz, pszDelim );
}

/*//////////////////////////////////////////////////////////////////////
*/

#ifdef	_MBCS	/*[*/
#define	_itot_s		_itoa_s
#else	/*][*/
#define	_itot_s		_itow_s
#endif	/*]*/

static	_inline
errno_t _itoa_s( int val, LPSTR psz, size_t cch, int rad )
{
	( void )cch;

	if ( NULL == psz )
	{
		return errno = EINVAL;
	}

	( void )itoa( val, psz, rad );

	return 0;
}

static	_inline
errno_t _itow_s( int val, LPWSTR psz, size_t cch, int rad )
{
	( void )cch;

	if ( NULL == psz )
	{
		return errno = EINVAL;
	}

	( void )_itow( val, psz, rad );

	return 0;
}

/*//////////////////////////////////////////////////////////////////////
*/

#ifdef	_MBCS	/*[*/
#define	_ltot_s		_ltoa_s
#else	/*][*/
#define	_ltot_s		_ltow_s
#endif	/*]*/

static	_inline
long _ltoa_s( long val, LPSTR psz, size_t cch, int rad )
{
	( void )cch;

	if ( NULL == psz )
	{
		return errno = EINVAL;
	}

	( void )ltoa( val, psz, rad );

	return 0;
}

static	_inline
long _ltow_s( long val, LPWSTR psz, size_t cch, int rad )
{
	( void )cch;

	if ( NULL == psz )
	{
		return errno = EINVAL;
	}

	( void )_ltow( val, psz, rad );

	return 0;
}

/*//////////////////////////////////////////////////////////////////////
*/

#ifdef	_MBCS	/*[*/
#define	_tfopen_s	fopen_s
#else	/*][*/
#define	_tfopen_s	_wfopen_s
#endif	/*]*/

static	_inline
errno_t fopen_s( FILE FAR* FAR* ppf, LPCSTR pszPath, LPCSTR pszMode )
{
	if ( NULL == ppf )
	{
		return errno = EINVAL;
	}

	*ppf = fopen( pszPath, pszMode );

	return 0;
}

static	_inline
errno_t _wfopen_s( FILE FAR* FAR* ppf, LPCWSTR pszPath, LPCWSTR pszMode )
{
	if ( NULL == ppf )
	{
		return errno = EINVAL;
	}

	*ppf = _wfopen( pszPath, pszMode );

	return 0;
}

/*//////////////////////////////////////////////////////////////////////
*/

#ifdef	_MBCS	/*[*/
#define	_vstprintf_s	vsprintf_s
#else	/*][*/
#define	_vstprintf_s	vswprintf_s
#endif	/*]*/

static	_inline
int vsprintf_s( LPSTR psz, size_t cch, LPCSTR pszForm, va_list vl )
{
	( void )cch;

	return vsprintf( psz, pszForm, vl );
}

static	_inline
int vswprintf_s( LPWSTR psz, size_t cch, LPCWSTR pszForm, va_list vl )
{
	( void )cch;

	return vswprintf( psz, pszForm, vl );
}

/*//////////////////////////////////////////////////////////////////////
*/

#ifdef	_MBCS	/*[*/
#define	_stprintf_s	sprintf_s
#else	/*][*/
#define	_stprintf_s	_swprintf_s
#endif	/*]*/

static	_inline
int sprintf_s( LPSTR psz, size_t cch, LPCSTR pszForm, ... )
{
	va_list	vl;
	int	ri;

	( void )cch;

	va_start( vl, pszForm );
	ri = vsprintf( psz, pszForm, vl );
	va_end( vl );

	return ri;
}

static	_inline
int _swprintf_s( LPWSTR psz, size_t cch, LPCWSTR pszForm, ... )
{
	va_list	vl;
	int	ri;

	( void )cch;

	va_start( vl, pszForm );
	ri = swprintf( psz, pszForm, vl );
	va_end( vl );

	return ri;
}

/*//////////////////////////////////////////////////////////////////////
*/

static	_inline
errno_t wcstombs_s( size_t FAR* pcchR, LPSTR pszD, size_t cchD, LPCWSTR pszS, size_t cchS )
{
	( void )pcchR;
	( void )cchD;

	( void )wcstombs( pszD, pszS, cchS );

	return 0;
}

/*//////////////////////////////////////////////////////////////////////
*/

static	_inline
errno_t _wcstombs_s_l( size_t FAR* pcchR, LPSTR pszD, size_t cchD, LPCWSTR pszS, size_t cchS, locale_t loc )
{
	( void )pcchR;
	( void )cchD;
	( void )loc;

	( void )wcstombs( pszD, pszS, cchS );

	return 0;
}

#ifdef	__cplusplus
}
#endif

#endif	/*]*/

#endif	/*]*/
